; File: C:\Data\Project\Sintendo\DC32Snes9x\Snes9x\apu.cpp
    .export     _S9xInitAPU
    .export     _S9xDeinitAPU
    .export     _S9xResetAPU
    .export     _S9xSetAPUDSP
    .export     `?S9xFixEnvelope@@YAXHEEE@Z`
    .export     _S9xSetAPUControl
    .export     _S9xSetAPUTimer
    .export     _S9xGetAPUDSP
    .import     `?NoiseFreq@@3PAHA`
    .import     `?S9xSetSoundVolume@@YAXHFF@Z`
    .import     `??3@YAXPAX@Z`
    .import     `?S9xSetEnvelopeRate@@YAXHKHH@Z`
    .import     `?S9xSetEchoFeedback@@YAXH@Z`
    .import     __imp__sprintf
    .import     _S9xAPUCycleLengths
    .import     `?S9xSetSoundType@@YAXHH@Z`
    .import     __imp___wfopen
    .import     `?S9xSetSoundSample@@YAXHG@Z`
    .import     _IAPU
    .import     _SoundData
    .import     `??2@YAPAXI@Z`
    .import     `?S9xSetSoundHertz@@YAXHH@Z`
    .import     _S9xAPUCycles
    .import     `?S9xSetEchoWriteEnable@@YAXE@Z`
    .import     `?S9xResetSound@@YAXE@Z`
    .import     `?S9xSetMasterVolume@@YAXFF@Z`
    .import     `?S9xSetFrequencyModulationEnable@@YAXE@Z`
    .import     _APU
    .import     __imp__mbstowcs
    .import     `?S9xSetEchoDelay@@YAXH@Z`
    .import     `?S9xSetSoundMode@@YAEHH@Z`
    .import     _Settings
    .import     `?S9xSetSoundMute@@YAEE@Z`
    .import     `?S9xSetSoundKeyOff@@YAXH@Z`
    .import     __imp__fread
    .import     `?S9xSetEchoEnable@@YAXE@Z`
    .import     _APUROM
    .import     `?S9xPlaySample@@YAXH@Z`
    .import     `?S9xSetSoundFrequency@@YAXHH@Z`
    .import     `?S9xSetEnvelopeHeight@@YAXHH@Z`
    .import     `?S9xSetSoundADSR@@YAXHHHHHH@Z`
    .import     `?S9xSetFilterCoefficient@@YAXHH@Z`
    .import     `?S9xSetEchoVolume@@YAXFF@Z`
    .import     _APURegisters
    .import     __imp__memmove
    .import     `?S9xGetEnvelopeHeight@@YAHH@Z`
    .import     _memset

    .section    .drectve, data, align=4
    .sdata      "-defaultlib:corelibc.lib -defaultlib:coredll.lib"

    .section    .data, data, align=4
`$S20561_?AttackRate@?4??S9xFixEnvelope@@YAXHEEE@Z@4PAKA`:
    .data.l     4100            ; 4100 = 0x1004
    .data.l     2600            ; 2600 = 0xa28
    .data.l     1500            ; 1500 = 0x5dc
    .data.l     1000            ; 1000 = 0x3e8
    .data.l     640             ; 640 = 0x280
    .data.l     380             ; 380 = 0x17c
    .data.l     260             ; 260 = 0x104
    .data.l     160             ; 160 = 0xa0
    .data.l     96              ; 96 = 0x60
    .data.l     64              ; 64 = 0x40
    .data.l     40              ; 40 = 0x28
    .data.l     24              ; 24 = 0x18
    .data.l     16              ; 16 = 0x10
    .data.l     10              ; 10 = 0xa
    .data.l     6
    .data.l     1
`$S20563_?DecayRate@?4??S9xFixEnvelope@@YAXHEEE@Z@4PAKA`:
    .data.l     1200            ; 1200 = 0x4b0
    .data.l     740             ; 740 = 0x2e4
    .data.l     440             ; 440 = 0x1b8
    .data.l     290             ; 290 = 0x122
    .data.l     180             ; 180 = 0xb4
    .data.l     110             ; 110 = 0x6e
    .data.l     74              ; 74 = 0x4a
    .data.l     37              ; 37 = 0x25
`$S20565_?SustainRate@?4??S9xFixEnvelope@@YAXHEEE@Z@4PAKA`:
    .data.l     -1              ; -1 = 0xffffffff
    .data.l     38000           ; 38000 = 0x9470
    .data.l     28000           ; 28000 = 0x6d60
    .data.l     24000           ; 24000 = 0x5dc0
    .data.l     19000           ; 19000 = 0x4a38
    .data.l     14000           ; 14000 = 0x36b0
    .data.l     12000           ; 12000 = 0x2ee0
    .data.l     9400            ; 9400 = 0x24b8
    .data.l     7100            ; 7100 = 0x1bbc
    .data.l     5900            ; 5900 = 0x170c
    .data.l     4700            ; 4700 = 0x125c
    .data.l     3500            ; 3500 = 0xdac
    .data.l     2900            ; 2900 = 0xb54
    .data.l     2400            ; 2400 = 0x960
    .data.l     1800            ; 1800 = 0x708
    .data.l     1500            ; 1500 = 0x5dc
    .data.l     1200            ; 1200 = 0x4b0
    .data.l     880             ; 880 = 0x370
    .data.l     740             ; 740 = 0x2e4
    .data.l     590             ; 590 = 0x24e
    .data.l     440             ; 440 = 0x1b8
    .data.l     370             ; 370 = 0x172
    .data.l     290             ; 290 = 0x122
    .data.l     220             ; 220 = 0xdc
    .data.l     180             ; 180 = 0xb4
    .data.l     150             ; 150 = 0x96
    .data.l     110             ; 110 = 0x6e
    .data.l     92              ; 92 = 0x5c
    .data.l     74              ; 74 = 0x4a
    .data.l     55              ; 55 = 0x37
    .data.l     37              ; 37 = 0x25
    .data.l     18              ; 18 = 0x12
`$S20574_?IncreaseRate@?BE@??S9xFixEnvelope@@YAXHEEE@Z@4PAKA`:
    .data.l     -1              ; -1 = 0xffffffff
    .data.l     4100            ; 4100 = 0x1004
    .data.l     3100            ; 3100 = 0xc1c
    .data.l     2600            ; 2600 = 0xa28
    .data.l     2000            ; 2000 = 0x7d0
    .data.l     1500            ; 1500 = 0x5dc
    .data.l     1300            ; 1300 = 0x514
    .data.l     1000            ; 1000 = 0x3e8
    .data.l     770             ; 770 = 0x302
    .data.l     640             ; 640 = 0x280
    .data.l     510             ; 510 = 0x1fe
    .data.l     380             ; 380 = 0x17c
    .data.l     320             ; 320 = 0x140
    .data.l     260             ; 260 = 0x104
    .data.l     190             ; 190 = 0xbe
    .data.l     160             ; 160 = 0xa0
    .data.l     130             ; 130 = 0x82
    .data.l     96              ; 96 = 0x60
    .data.l     80              ; 80 = 0x50
    .data.l     64              ; 64 = 0x40
    .data.l     48              ; 48 = 0x30
    .data.l     40              ; 40 = 0x28
    .data.l     32              ; 32 = 0x20
    .data.l     24              ; 24 = 0x18
    .data.l     20              ; 20 = 0x14
    .data.l     16              ; 16 = 0x10
    .data.l     12              ; 12 = 0xc
    .data.l     10              ; 10 = 0xa
    .data.l     8
    .data.l     6
    .data.l     4
    .data.l     2
`$S20576_?DecreaseRateExp@?BE@??S9xFixEnvelope@@YAXHEEE@Z@4PAKA`:
    .data.l     -1              ; -1 = 0xffffffff
    .data.l     38000           ; 38000 = 0x9470
    .data.l     28000           ; 28000 = 0x6d60
    .data.l     24000           ; 24000 = 0x5dc0
    .data.l     19000           ; 19000 = 0x4a38
    .data.l     14000           ; 14000 = 0x36b0
    .data.l     12000           ; 12000 = 0x2ee0
    .data.l     9400            ; 9400 = 0x24b8
    .data.l     7100            ; 7100 = 0x1bbc
    .data.l     5900            ; 5900 = 0x170c
    .data.l     4700            ; 4700 = 0x125c
    .data.l     3500            ; 3500 = 0xdac
    .data.l     2900            ; 2900 = 0xb54
    .data.l     2400            ; 2400 = 0x960
    .data.l     1800            ; 1800 = 0x708
    .data.l     1500            ; 1500 = 0x5dc
    .data.l     1200            ; 1200 = 0x4b0
    .data.l     880             ; 880 = 0x370
    .data.l     740             ; 740 = 0x2e4
    .data.l     590             ; 590 = 0x24e
    .data.l     440             ; 440 = 0x1b8
    .data.l     370             ; 370 = 0x172
    .data.l     290             ; 290 = 0x122
    .data.l     220             ; 220 = 0xdc
    .data.l     180             ; 180 = 0xb4
    .data.l     150             ; 150 = 0x96
    .data.l     110             ; 110 = 0x6e
    .data.l     92              ; 92 = 0x5c
    .data.l     74              ; 74 = 0x4a
    .data.l     55              ; 55 = 0x37
    .data.l     37              ; 37 = 0x25
    .data.l     18              ; 18 = 0x12
;  390: {
    .align      4

    .section    .text, code, align=4

_S9xInitAPU: .entry
    mov.l       r8,@-sp
    mov.l       r9,@-sp
    mov.l       r10,@-sp
    sts.l       pr,@-sp
    add.l       #-16,sp         ; -16 = 0xfffffff0
    .prolog
    mov.b       #32,r10         ; 32 = 0x20
    mov.l       @(532,pc),r8    ; = _IAPU
    mov.b       #36,r9          ; 36 = 0x24
    mov.l       @(508,pc),r0    ; = `??2@YAPAXI@Z`
    add.l       r8,r9
;  391:     IAPU.RAM = new uint8 [0x10000];
    mov.l       @(476,pc),r4    ; = 65536
    jsr         @r0
    add.l       r8,r10
    mov.l       r0,@(4,r8)
;  392:     IAPU.ShadowRAM = new uint8 [0x10000];
    mov.l       @(496,pc),r0    ; = `??2@YAPAXI@Z`
    mov.l       @(468,pc),r4    ; = 65536
    jsr         @r0
    nop
    mov.l       r0,@(32,r8)     ; 32 = 0x20
;  393:     IAPU.CachedSamples = new uint8 [0x40000];
    mov.l       @(488,pc),r0    ; = `??2@YAPAXI@Z`
    mov.l       @(464,pc),r4    ; = 262144
    jsr         @r0
    nop
    mov.l       r0,@(36,r8)     ; 36 = 0x24
;  395:     if (!IAPU.RAM || !IAPU.ShadowRAM || !IAPU.CachedSamples)
    mov.l       @(4,r8),r1
    tst.l       r1,r1
    bt          +10             ; +10 = 0xa, pc+10 = L20403
    mov.l       @r10,r3
    tst.l       r3,r3
    bt          +4              ; pc+4 = L20403
    mov.l       @r9,r2
    tst.l       r2,r2
    bf          +2              ; pc+2 = L20402
L20403:
;  396: 	return (FALSE);
    bra         +2              ; pc+2 = L20395
    mov.b       #0,r0
L20402:
    mov.b       #1,r0
L20395:
    add.l       #16,sp          ; 16 = 0x10
    lds.l       @sp+,pr
    mov.l       @sp+,r10
    mov.l       @sp+,r9
    rts
    mov.l       @sp+,r8
    .endf
;  402: {
    .align      4

_S9xDeinitAPU: .entry
    mov.l       r8,@-sp
    sts.l       pr,@-sp
    add.l       #-16,sp         ; -16 = 0xfffffff0
    .prolog
;  403:     delete IAPU.RAM;
    mov.l       @(440,pc),r0    ; = `??3@YAXPAX@Z`
    mov.l       @(452,pc),r8    ; = _IAPU
    jsr         @r0
    mov.l       @(4,r8),r4
;  404:     delete IAPU.ShadowRAM;
    mov.l       @(432,pc),r0    ; = `??3@YAXPAX@Z`
    jsr         @r0
    mov.l       @(32,r8),r4     ; 32 = 0x20
;  405:     delete IAPU.CachedSamples;
    mov.l       @(424,pc),r0    ; = `??3@YAXPAX@Z`
    jsr         @r0
    mov.l       @(36,r8),r4     ; 36 = 0x24
;  406: }
    add.l       #16,sp          ; 16 = 0x10
    lds.l       @sp+,pr
    rts
    mov.l       @sp+,r8
    .endf
;  411: {
    .align      4

_S9xResetAPU: .entry
    mov.l       r8,@-sp
    mov.l       r9,@-sp
    mov.l       r10,@-sp
    mov.l       r11,@-sp
    mov.l       r12,@-sp
    sts.l       pr,@-sp
    add.l       #-16,sp         ; -16 = 0xfffffff0
    .prolog
    mov.l       @(400,pc),r0    ; = _memset
    mov.l       @(408,pc),r8    ; = _IAPU
    mov.l       @(400,pc),r9    ; = _APU
    mov.l       @(368,pc),r11   ; = _APURegisters
;  412:     memset (IAPU.RAM, 0xff, 0x10000);
    mov.w       @(346,pc),r5    ; = 255
    mov.l       @(352,pc),r6    ; = 65536
    jsr         @r0
    mov.l       @(4,r8),r4
;  413:     ZeroMemory (IAPU.ShadowRAM, 0x10000);
    mov.b       #0,r5
    mov.l       @(380,pc),r0    ; = _memset
    mov.l       @(344,pc),r6    ; = 65536
    jsr         @r0
    mov.l       @(32,r8),r4     ; 32 = 0x20
;  414:     ZeroMemory (IAPU.CachedSamples, 0x40000);
    mov.l       @(372,pc),r0    ; = _memset
    mov.b       #0,r5
    mov.l       @(340,pc),r6    ; = 262144
    jsr         @r0
    mov.l       @(36,r8),r4     ; 36 = 0x24
;  415:     ZeroMemory (APU.OutPorts, 4);
    mov.b       #11,r4          ; 11 = 0xb
    mov.l       @(348,pc),r3    ; = __imp__memmove
    add.l       r9,r4
    mov.l       @(372,pc),r12   ; = _APUROM
    mov.b       #0,r5
    mov.b       r5,@-r4
    mov.b       #64,r6          ; 64 = 0x40
    mov.b       r5,@-r4
    mov.b       r5,@-r4
    mov.b       r5,@-r4
;  416:     IAPU.DirectPage = IAPU.RAM;
    mov.l       @(4,r8),r1
    mov.l       r1,@(8,r8)
;  417:     memmove (&IAPU.RAM [0xffc0], APUROM, sizeof (APUROM));
    mov.l       @r3,r3
    mov.l       @(4,r8),r4
    mov.l       @(304,pc),r2    ; = 65472
    add.l       r2,r4
    jsr         @r3
    mov.l       r12,r5
;  418:     memmove (APU.ExtraRAM, APUROM, sizeof (APUROM));
    mov.l       r9,r4
    mov.w       @(278,pc),r1    ; = 139
    mov.l       r12,r5
    mov.l       @(308,pc),r2    ; = __imp__memmove
    mov.b       #64,r6          ; 64 = 0x40
    mov.l       @r2,r2
    jsr         @r2
    add.l       r1,r4
    mov.l       @(324,pc),r3    ; = _IAPU
    mov.l       @(268,pc),r0    ; = 65534
    mov.l       @(4,r3),r4
;  419:     IAPU.PC = IAPU.RAM + IAPU.RAM [0xfffe] + (IAPU.RAM [0xffff] << 8);
    mov.l       r4,r2
    mov.b       @(r0,r4),r1
    add.l       #1,r0
    mov.b       @(r0,r4),r3
    extu.b      r1,r1
    add.l       r1,r2
    extu.b      r3,r3
    shll8.l     r3
    add.l       r3,r2
    mov.l       r2,@r8
;  420:     APU.Cycles = 0;
    mov.b       #0,r0
    mov.l       r0,@r9
;  421:     APURegisters.YA.W = 0;
    mov.b       #0,r2
    mov.w       r0,@(2,r11)
;  422:     APURegisters.X = 0;
    mov.b       r0,@(4,r11)
;  423:     APURegisters.S = 0xff;
    mov.w       @(230,pc),r0    ; = 255
    mov.b       r0,@(5,r11)
;  424:     APURegisters.P = 0;
    mov.b       r2,@r11
;  425:     S9xAPUUnpackStatus ();
; File: C:\Data\Project\Sintendo\DC32Snes9x\Snes9x\apu.h
;   85: {
;   86:     IAPU._Zero = ((APURegisters.P & Zero) == 0) | (APURegisters.P & Negative);
    extu.b      r2,r3
    mov.l       r3,r0
    nop
    tst.l       #2,r0
    mov.w       @(212,pc),r2    ; = 128
    and.l       r2,r3
    movt.l      r0
    or.l        r3,r0
    ldc.l       r8,gbr
    mov.b       #-6,r1          ; -6 = 0xfffffffa
    mov.b       r0,@(41,gbr)    ; 41 = 0x29
;   87:     IAPU._Carry = (APURegisters.P & Carry);
    mov.b       @r11,r3
    extu.b      r3,r0
    and.l       #1,r0
    mov.b       r0,@(40,gbr)    ; 40 = 0x28
;   88:     IAPU._Overflow = (APURegisters.P & Overflow) >> 6;
    mov.b       @r11,r2
    extu.b      r2,r0
    and.l       #64,r0          ; 64 = 0x40
    shad.l      r1,r0
    mov.b       r0,@(42,gbr)    ; 42 = 0x2a
;   89: }
; File: C:\Data\Project\Sintendo\DC32Snes9x\Snes9x\apu.cpp
;  425:     S9xAPUUnpackStatus ();
;  426:     APURegisters.PC = 0;
    mov.l       @(248,pc),r3    ; = _Settings
    mov.b       #0,r0
    mov.w       r0,@(6,r11)
;  427:     IAPU.APUExecuting = Settings.APUEnabled;
    mov.b       #0,r1
    mov.b       @r3,r0
    mov.b       r0,@(12,r8)     ; 12 = 0xc
;  429:     IAPU.WaitAddress1 = NULL;
    mov.l       r1,@(20,r8)     ; 20 = 0x14
;  430:     IAPU.WaitAddress2 = NULL;
    mov.l       r1,@(24,r8)     ; 24 = 0x18
;  431:     IAPU.WaitCounter = 0;
    mov.l       r1,@(28,r8)     ; 28 = 0x1c
;  433:     APU.ShowROM = TRUE;
    mov.b       #1,r1
    mov.l       r1,r0
    nop
    mov.b       r0,@(4,r9)
;  434:     IAPU.RAM [0xf1] = 0x80;
    mov.l       r9,r5
    mov.w       @(152,pc),r0    ; = 128
    mov.b       #24,r10         ; 24 = 0x18
    ldc.l       r4,gbr
    mov.b       #36,r7          ; 36 = 0x24
    mov.b       r0,@(241,gbr)   ; 241 = 0xf1
;  436:     int i;
;  438:     for (i = 0; i < 3; i++)
    add.l       #52,r0          ; 52 = 0x34
    add.l       r0,r5
    add.l       r5,r10
    add.l       r5,r7
    mov.b       #39,r6          ; 39 = 0x27
    add.l       r5,r6
    add.l       #30,r5          ; 30 = 0x1e
    mov.b       #0,r4
L20413:
;  439:     {
;  440: 	APU.TimerEnabled [i] = FALSE;
    mov.b       #0,r1
    mov.b       r1,@r7
;  441: 	APU.TimerValueWritten [i] = 0;
    mov.b       r1,@r6
;  442: 	APU.TimerTarget [i] = 0;
    mov.w       r1,@r5
;  443: 	APU.Timer [i] = 0;
    mov.w       r1,@r10
;  444:     }
    add.l       #1,r4
    mov.b       #3,r2
    cmp/gt.l    r4,r2
    add.l       #1,r7
    add.l       #1,r6
    add.l       #2,r5
    bt/s        -26             ; -26 = 0xffffffe6, pc-26 = L20413
    add.l       #2,r10
;  445:     for (int j = 0; j < 0x80; j++)
    mov.l       @(152,pc),r11   ; = _APU
    add.l       #11,r11         ; 11 = 0xb
    mov.w       @(96,pc),r6     ; = 128
    mov.l       r11,r5
    mov.b       #0,r4
L20422:
;  446: 	APU.DSP [j] = 0;
    mov.b       #0,r1
    mov.b       r1,@r5
    add.l       #1,r4
    cmp/gt.l    r4,r6
    bt/s        -12             ; -12 = 0xfffffff4, pc-12 = L20422
    add.l       #1,r5
    mov.l       @(140,pc),r10   ; = _IAPU
    add.l       #52,r10         ; 52 = 0x34
;  448:     IAPU.TwoCycles = IAPU.OneCycle * 2;
    mov.l       @r10,r3
    shll.l      r3
    mov.l       r3,@(56,r8)     ; 56 = 0x38
;  450:     for (i = 0; i < 256; i++)
    mov.b       #0,r4
    mov.l       @(96,pc),r6     ; = _S9xAPUCycles
    mov.l       @(96,pc),r5     ; = _S9xAPUCycleLengths
    mov.w       @(68,pc),r7     ; = 256
L20430:
;  451: 	S9xAPUCycles [i] = S9xAPUCycleLengths [i] * IAPU.OneCycle;
    mov.l       @r5+,r1
    mov.l       @r10,r2
    mul.l       r1,r2
    sts.l       macl,r3
    mov.l       r3,@r6
    add.l       #1,r4
    cmp/gt.l    r4,r7
    bt/s        -18             ; -18 = 0xffffffee, pc-18 = L20430
    add.l       #4,r6
;  453:     APU.DSP [APU_ENDX] = 0;
    mov.b       #0,r0
    ldc.l       r11,gbr
    mov.b       r0,@(124,gbr)   ; 124 = 0x7c
;  454:     APU.DSP [APU_KOFF] = 0;
    mov.b       r0,@(92,gbr)    ; 92 = 0x5c
;  455:     APU.DSP [APU_KON] = 0;
    mov.b       r0,@(76,gbr)    ; 76 = 0x4c
;  456:     APU.DSP [APU_FLG] = APU_MUTE | APU_ECHO_DISABLED;
    mov.b       #96,r0          ; 96 = 0x60
    mov.b       r0,@(108,gbr)   ; 108 = 0x6c
;  457:     APU.KeyedChannels = 0;
    mov.b       #0,r0
    mov.b       r0,@(6,r9)
;  459:     S9xResetSound (TRUE);
    mov.l       @(80,pc),r0     ; = `?S9xResetSound@@YAXE@Z`
    jsr         @r0
    mov.b       #1,r4
;  460:     S9xSetEchoEnable (0);
    mov.l       @(92,pc),r0     ; = `?S9xSetEchoEnable@@YAXE@Z`
    jsr         @r0
    mov.b       #0,r4
;  461: }
    add.l       #16,sp          ; 16 = 0x10
    lds.l       @sp+,pr
    mov.l       @sp+,r12
    mov.l       @sp+,r11
    mov.l       @sp+,r10
    mov.l       @sp+,r9
    rts
    mov.l       @sp+,r8
L20892:
    .data.w     128             ; 128 = 0x80
    .data.w     139             ; 139 = 0x8b
    .data.w     255             ; 255 = 0xff
    .data.w     256             ; 256 = 0x100
    .data.l     65534           ; 65534 = 0xfffe
    .data.l     65536           ; 65536 = 0x10000
    .data.l     65472           ; 65472 = 0xffc0
    .data.l     262144          ; 262144 = 0x40000
    .data.l     _APURegisters
    .data.l     _S9xAPUCycles
    .data.l     _S9xAPUCycleLengths
    .data.l     __imp__memmove
    .data.l     `??2@YAPAXI@Z`
    .data.l     `??3@YAXPAX@Z`
    .data.l     _memset
    .data.l     _APU
    .data.l     `?S9xResetSound@@YAXE@Z`
    .data.l     _IAPU
    .data.l     _APUROM
    .data.l     _Settings
    .data.l     `?S9xSetEchoEnable@@YAXE@Z`
    .endf
;  464: {
    .align      4

_S9xSetAPUDSP: .entry
    mov.l       r8,@-sp
    mov.l       r9,@-sp
    mov.l       r10,@-sp
    mov.l       r11,@-sp
    mov.l       r12,@-sp
    mov.l       r13,@-sp
    sts.l       pr,@-sp
    mov.l       r4,r8
    add.l       #-16,sp         ; -16 = 0xfffffff0
    .prolog
;  465:     uint8 reg = IAPU.RAM [0xf2];
    mov.l       @(32,pc),r1     ; = _IAPU
    mov.w       @(26,pc),r0     ; = 242
    mov.l       @(4,r1),r1
    mov.b       @(r0,r1),r1
    extu.b      r1,r9
;  466:     int i;
;  468:     switch (reg)
;  469:     {
    mov.l       r9,r4
    mov.b       #127,r2         ; 127 = 0x7f
    cmp/hi.l    r2,r4
    bf          +2              ; pc+2 = L20901
    bra         +1226           ; +1226 = 0x4ca, pc+1226 = L20551
    nop
L20901:
    .align      4
    shll.l      r4
    mova.l      L20775,r0
    mov.w       @(r0,r4),r0
    braf        r0
    nop
L20774:
L20893:
    .data.w     242             ; 242 = 0xf2
    .data.l     _IAPU
    .align      4
L20775:
    .data.w     L20520 - L20774
    .data.w     L20524 - L20774
    .data.w     L20528 - L20774
    .data.w     L20529 - L20774
    .data.w     L20530 - L20774
    .data.w     L20532 - L20774
    .data.w     L20534 - L20774
    .data.w     L20536 - L20774
    .data.w     L20444 - L20774
    .data.w     L20444 - L20774
    .data.w     L20551 - L20774
    .data.w     L20551 - L20774
    .data.w     L20476 - L20774
    .data.w     L20545 - L20774
    .data.w     L20551 - L20774
    .data.w     L20549 - L20774
    .data.w     L20520 - L20774
    .data.w     L20524 - L20774
    .data.w     L20528 - L20774
    .data.w     L20529 - L20774
    .data.w     L20530 - L20774
    .data.w     L20532 - L20774
    .data.w     L20534 - L20774
    .data.w     L20536 - L20774
    .data.w     L20444 - L20774
    .data.w     L20444 - L20774
    .data.w     L20551 - L20774
    .data.w     L20551 - L20774
    .data.w     L20480 - L20774
    .data.w     L20551 - L20774
    .data.w     L20551 - L20774
    .data.w     L20549 - L20774
    .data.w     L20520 - L20774
    .data.w     L20524 - L20774
    .data.w     L20528 - L20774
    .data.w     L20529 - L20774
    .data.w     L20530 - L20774
    .data.w     L20532 - L20774
    .data.w     L20534 - L20774
    .data.w     L20536 - L20774
    .data.w     L20444 - L20774
    .data.w     L20444 - L20774
    .data.w     L20551 - L20774
    .data.w     L20551 - L20774
    .data.w     L20484 - L20774
    .data.w     L20541 - L20774
    .data.w     L20551 - L20774
    .data.w     L20549 - L20774
    .data.w     L20520 - L20774
    .data.w     L20524 - L20774
    .data.w     L20528 - L20774
    .data.w     L20529 - L20774
    .data.w     L20530 - L20774
    .data.w     L20532 - L20774
    .data.w     L20534 - L20774
    .data.w     L20536 - L20774
    .data.w     L20444 - L20774
    .data.w     L20444 - L20774
    .data.w     L20551 - L20774
    .data.w     L20551 - L20774
    .data.w     L20488 - L20774
    .data.w     L20461 - L20774
    .data.w     L20551 - L20774
    .data.w     L20549 - L20774
    .data.w     L20520 - L20774
    .data.w     L20524 - L20774
    .data.w     L20528 - L20774
    .data.w     L20529 - L20774
    .data.w     L20530 - L20774
    .data.w     L20532 - L20774
    .data.w     L20534 - L20774
    .data.w     L20536 - L20774
    .data.w     L20444 - L20774
    .data.w     L20444 - L20774
    .data.w     L20551 - L20774
    .data.w     L20551 - L20774
    .data.w     L20507 - L20774
    .data.w     L20543 - L20774
    .data.w     L20551 - L20774
    .data.w     L20549 - L20774
    .data.w     L20520 - L20774
    .data.w     L20524 - L20774
    .data.w     L20528 - L20774
    .data.w     L20529 - L20774
    .data.w     L20530 - L20774
    .data.w     L20532 - L20774
    .data.w     L20534 - L20774
    .data.w     L20536 - L20774
    .data.w     L20444 - L20774
    .data.w     L20444 - L20774
    .data.w     L20551 - L20774
    .data.w     L20551 - L20774
    .data.w     L20493 - L20774
    .data.w     L20444 - L20774
    .data.w     L20551 - L20774
    .data.w     L20549 - L20774
    .data.w     L20520 - L20774
    .data.w     L20524 - L20774
    .data.w     L20528 - L20774
    .data.w     L20529 - L20774
    .data.w     L20530 - L20774
    .data.w     L20532 - L20774
    .data.w     L20534 - L20774
    .data.w     L20536 - L20774
    .data.w     L20444 - L20774
    .data.w     L20444 - L20774
    .data.w     L20551 - L20774
    .data.w     L20551 - L20774
    .data.w     L20447 - L20774
    .data.w     L20444 - L20774
    .data.w     L20551 - L20774
    .data.w     L20549 - L20774
    .data.w     L20520 - L20774
    .data.w     L20524 - L20774
    .data.w     L20528 - L20774
    .data.w     L20529 - L20774
    .data.w     L20530 - L20774
    .data.w     L20532 - L20774
    .data.w     L20534 - L20774
    .data.w     L20536 - L20774
    .data.w     L20444 - L20774
    .data.w     L20444 - L20774
    .data.w     L20551 - L20774
    .data.w     L20551 - L20774
    .data.w     L20492 - L20774
    .data.w     L20548 - L20774
    .data.w     L20551 - L20774
    .data.w     L20549 - L20774
L20447:
;  471: 	if (byte & APU_SOFT_RESET)
    mov.w       @(318,pc),r1    ; = 128
    tst.l       r1,r8
    bt          +44             ; +44 = 0x2c, pc+44 = L20448
;  472: 	{
;  473: 	    APU.DSP [reg] = APU_MUTE | APU_ECHO_DISABLED | (byte & 0x1f);
    mov.b       #31,r2          ; 31 = 0x1f
    mov.l       @(328,pc),r4    ; = _APU
    mov.l       r8,r3
    and.l       r2,r3
    mov.l       r9,r0
    mov.b       #96,r2          ; 96 = 0x60
    or.l        r2,r3
    add.l       #11,r4          ; 11 = 0xb
    mov.b       r3,@(r0,r4)
;  474: 	    APU.DSP [APU_ENDX] = 0;
    add.l       #60,r4          ; 60 = 0x3c
    mov.b       #0,r0
    ldc.l       r4,gbr
    mov.b       r0,@(64,gbr)    ; 64 = 0x40
;  475: 	    APU.DSP [APU_KOFF] = 0;
    mov.b       r0,@(32,gbr)    ; 32 = 0x20
;  476: 	    APU.DSP [APU_KON] = 0;
    mov.b       r0,@(16,gbr)    ; 16 = 0x10
;  477: 	    S9xSetEchoWriteEnable (FALSE);
    mov.l       @(320,pc),r0    ; = `?S9xSetEchoWriteEnable@@YAXE@Z`
    jsr         @r0
    mov.b       #0,r4
;  483: 	    S9xResetSound (FALSE);
    mov.l       @(300,pc),r0    ; = `?S9xResetSound@@YAXE@Z`
    jsr         @r0
    mov.b       #0,r4
;  484: 	}
;  485: 	else
    bra         +88             ; +88 = 0x58, pc+88 = L20449
    nop
L20448:
;  486: 	{
;  487: 	    S9xSetEchoWriteEnable (!(byte & APU_ECHO_DISABLED));
    mov.l       r8,r0
    nop
    tst.l       #32,r0          ; 32 = 0x20
    mov.l       @(300,pc),r0    ; = `?S9xSetEchoWriteEnable@@YAXE@Z`
    jsr         @r0
    movt.l      r4
;  488: 	    if (byte & APU_MUTE)
    mov.l       r8,r0
    nop
    tst.l       #64,r0          ; 64 = 0x40
    bt          +8              ; pc+8 = L20450
;  489: 	    {
;  494: 		S9xSetSoundMute (TRUE);
    mov.l       @(260,pc),r0    ; = `?S9xSetSoundMute@@YAEE@Z`
    jsr         @r0
    mov.b       #1,r4
;  495: 	    }
;  496: 	    else
    bra         +6              ; pc+6 = L20451
    nop
L20450:
;  497: 		S9xSetSoundMute (FALSE);
    mov.l       @(252,pc),r0    ; = `?S9xSetSoundMute@@YAEE@Z`
    jsr         @r0
    mov.b       #0,r4
L20451:
    mov.l       @(256,pc),r13   ; = _SoundData
    mov.l       r13,r10
    mov.w       @(228,pc),r0    ; = 1540
    add.l       r0,r10
;  499: 	    SoundData.noise_hertz = NoiseFreq [byte & 0x1f];
    mov.l       @(232,pc),r2    ; = `?NoiseFreq@@3PAHA`
    mov.l       r8,r0
    nop
    and.l       #31,r0          ; 31 = 0x1f
    mov.w       @(218,pc),r12   ; = 184
    shll2.l     r0
    mov.l       @(r0,r2),r2
    mov.b       #0,r11
    mov.l       r2,@r10
;  500: 	    for (i = 0; i < 8; i++)
    add.l       #48,r13         ; 48 = 0x30
L20452:
;  501: 	    {
;  502: 		if (SoundData.channels [i].type == SOUND_NOISE)
    mov.l       @(4,r13),r0
    cmp/eq.l    #1,r0
    bf          +6              ; pc+6 = L20459
;  503: 		    S9xSetSoundFrequency (i, SoundData.noise_hertz);
    mov.l       @(228,pc),r0    ; = `?S9xSetSoundFrequency@@YAXHH@Z`
    mov.l       @r10,r5
    jsr         @r0
    mov.l       r11,r4
;  504: 	    }
L20459:
    add.l       #1,r11
    mov.b       #8,r2
    cmp/gt.l    r11,r2
    bt/s        -24             ; -24 = 0xffffffe8, pc-24 = L20452
    add.l       r12,r13
;  505: 	}
L20449:
;  506: 	break;
    bra         +810            ; +810 = 0x32a, pc+810 = L20444
    nop
L20461:
;  508: 	if (byte != APU.DSP [APU_NON])
    mov.l       @(192,pc),r2    ; = _APU
    mov.b       #72,r0          ; 72 = 0x48
    mov.b       @(r0,r2),r2
    extu.b      r2,r2
    cmp/eq.l    r2,r8
    bf          +2              ; pc+2 = L20902
    bra         +794            ; +794 = 0x31a, pc+794 = L20444
    nop
L20902:
;  509: 	{
;  514: 	    uint8 mask = 1;
    mov.b       #1,r11
;  515: 	    for (int c = 0; c < 8; c++, mask <<= 1)
    mov.b       #0,r10
L20465:
;  516: 	    {
;  517: 		int type;
;  518: 		if (byte & mask)
    tst.l       r11,r8
    mov.b       #-1,r5          ; -1 = 0xffffffff
    negc.l      r5,r5
;  519: 		{
;  520: 		    type = SOUND_NOISE;
;  530: 		}
;  531: 		else
;  532: 		{
;  533: 		    type = SOUND_SAMPLE;
;  541: 		}
;  542: 		S9xSetSoundType (c, type);
    mov.l       @(184,pc),r0    ; = `?S9xSetSoundType@@YAXHH@Z`
    jsr         @r0
    mov.l       r10,r4
;  543: 	    }
    add.l       #1,r10
    shll.l      r11
    mov.b       #8,r3
    cmp/gt.l    r10,r3
    bt/s        -24             ; -24 = 0xffffffe8, pc-24 = L20465
    extu.b      r11,r11
;  548: 	}
;  549: 	break;
    bra         +762            ; +762 = 0x2fa, pc+762 = L20444
    nop
L20476:
    mov.l       @(144,pc),r7    ; = _APU
    add.l       #11,r7          ; 11 = 0xb
;  551: 	if (byte != APU.DSP [APU_MVOL_LEFT])
    mov.b       @(12,r7),r0     ; 12 = 0xc
    extu.b      r0,r3
    cmp/eq.l    r3,r8
    bf          +2              ; pc+2 = L20903
    bra         +746            ; +746 = 0x2ea, pc+746 = L20444
    nop
L20903:
;  552: 	{
;  558: 		S9xSetMasterVolume ((signed char) byte,
;  559: 				    (signed char) APU.DSP [APU_MVOL_RIGHT]);
    mov.b       #28,r0          ; 28 = 0x1c
    mov.b       @(r0,r7),r5
    mov.l       @(148,pc),r0    ; = `?S9xSetMasterVolume@@YAXFF@Z`
    jsr         @r0
    exts.b      r8,r4
;  560: 	}
;  561: 	break;
    bra         +732            ; +732 = 0x2dc, pc+732 = L20444
    nop
L20480:
    mov.l       @(116,pc),r7    ; = _APU
    add.l       #11,r7          ; 11 = 0xb
;  563: 	if (byte != APU.DSP [APU_MVOL_RIGHT])
    mov.b       #28,r0          ; 28 = 0x1c
    mov.b       @(r0,r7),r1
    extu.b      r1,r1
    cmp/eq.l    r1,r8
    bf          +2              ; pc+2 = L20904
    bra         +714            ; +714 = 0x2ca, pc+714 = L20444
    nop
L20904:
;  564: 	{
;  570: 		S9xSetMasterVolume ((signed char) APU.DSP [APU_MVOL_LEFT],
;  571: 				    (signed char) byte);
    mov.b       @(12,r7),r0     ; 12 = 0xc
    mov.l       r0,r4
    mov.l       @(116,pc),r0    ; = `?S9xSetMasterVolume@@YAXFF@Z`
    jsr         @r0
    exts.b      r8,r5
;  572: 	}
;  573: 	break;
    bra         +700            ; +700 = 0x2bc, pc+700 = L20444
    nop
L20484:
    mov.l       @(84,pc),r7     ; = _APU
    add.l       #11,r7          ; 11 = 0xb
;  575: 	if (byte != APU.DSP [APU_EVOL_LEFT])
    mov.b       #44,r0          ; 44 = 0x2c
    mov.b       @(r0,r7),r2
    extu.b      r2,r2
    cmp/eq.l    r2,r8
    bf          +2              ; pc+2 = L20905
    bra         +682            ; +682 = 0x2aa, pc+682 = L20444
    nop
L20905:
;  576: 	{
;  582: 		S9xSetEchoVolume ((signed char) byte,
;  583: 				  (signed char) APU.DSP [APU_EVOL_RIGHT]);
    mov.b       #60,r0          ; 60 = 0x3c
    mov.b       @(r0,r7),r5
    mov.l       @(48,pc),r0     ; = `?S9xSetEchoVolume@@YAXFF@Z`
    jsr         @r0
    exts.b      r8,r4
;  584: 	}
;  585: 	break;
    bra         +668            ; +668 = 0x29c, pc+668 = L20444
    nop
L20488:
    mov.l       @(52,pc),r7     ; = _APU
    add.l       #11,r7          ; 11 = 0xb
;  587: 	if (byte != APU.DSP [APU_EVOL_RIGHT])
    mov.b       #60,r0          ; 60 = 0x3c
    mov.b       @(r0,r7),r3
    extu.b      r3,r3
    cmp/eq.l    r3,r8
    bf          +2              ; pc+2 = L20906
    bra         +650            ; +650 = 0x28a, pc+650 = L20444
    nop
L20906:
;  588: 	{
;  594: 		S9xSetEchoVolume ((signed char) APU.DSP [APU_EVOL_LEFT],
;  595: 				  (signed char) byte);
    mov.b       #44,r0          ; 44 = 0x2c
    mov.b       @(r0,r7),r4
    mov.l       @(16,pc),r0     ; = `?S9xSetEchoVolume@@YAXFF@Z`
    jsr         @r0
    exts.b      r8,r5
;  596: 	}
;  597: 	break;
    bra         +636            ; +636 = 0x27c, pc+636 = L20444
    nop
L20492:
;  603: 	byte = 0;
    bra         +632            ; +632 = 0x278, pc+632 = L20444
    mov.b       #0,r8
L20894:
    .data.w     128             ; 128 = 0x80
    .data.w     1540            ; 1540 = 0x604
    .data.w     184             ; 184 = 0xb8
    .data.l     `?S9xSetEchoVolume@@YAXFF@Z`
    .data.l     `?NoiseFreq@@3PAHA`
    .data.l     `?S9xSetSoundMute@@YAEE@Z`
    .data.l     _APU
    .data.l     `?S9xResetSound@@YAXE@Z`
    .data.l     _SoundData
    .data.l     `?S9xSetSoundFrequency@@YAXHH@Z`
    .data.l     `?S9xSetSoundType@@YAXHH@Z`
    .data.l     `?S9xSetEchoWriteEnable@@YAXE@Z`
    .data.l     `?S9xSetMasterVolume@@YAXFF@Z`
L20493:
;  607: 	if (byte)
    tst.l       r8,r8
    bt          +68             ; +68 = 0x44, pc+68 = L20718
;  608: 	{
;  609: 	    uint8 mask = 1;
    mov.l       @(620,pc),r10   ; = _APU
    add.l       #71,r10         ; 71 = 0x47
    mov.b       #1,r11
;  614: 	    for (int c = 0; c < 8; c++, mask <<= 1)
    mov.b       #0,r9
L20497:
;  615: 	    {
;  616: 		if ((byte & mask) != 0)
    tst.l       r11,r8
    bt          +40             ; +40 = 0x28, pc+40 = L20504
    mov.l       @(608,pc),r4    ; = _APU
    add.l       #6,r4
;  617: 		{
;  623: 		    if (APU.KeyedChannels & mask)
    mov.b       @r4,r2
    extu.b      r2,r2
    tst.l       r11,r2
    bt          +28             ; +28 = 0x1c, pc+28 = L20505
;  624: 		    {
;  625: 			{
;  626: 			    APU.KeyedChannels &= ~mask;
    not.l       r11,r5
    mov.b       @r4,r1
    extu.b      r1,r1
    extu.b      r5,r2
    and.l       r2,r1
    mov.b       r1,@r4
;  627: 			    APU.DSP [APU_KON] &= ~mask;
    extu.b      r5,r1
    ldc.l       r10,gbr
    mov.b       @(16,gbr),r0    ; 16 = 0x10
    extu.b      r0,r0
    and.l       r1,r0
    mov.b       r0,@(16,gbr)    ; 16 = 0x10
;  629: 			    S9xSetSoundKeyOff (c);
    mov.l       @(576,pc),r0    ; = `?S9xSetSoundKeyOff@@YAXH@Z`
    jsr         @r0
    mov.l       r9,r4
;  630: 			}
;  631: 		    }
;  632: 		}
L20505:
;  633: 	    }
L20504:
    add.l       #1,r9
    shll.l      r11
    mov.b       #8,r2
    cmp/gt.l    r9,r2
    bt/s        -58             ; -58 = 0xffffffc6, pc-58 = L20497
    extu.b      r11,r11
;  638: 	}
;  639: 	APU.DSP [APU_KOFF] = byte;
    bra         +4              ; pc+4 = L20494
    nop
L20718:
    mov.l       @(552,pc),r10   ; = _APU
    add.l       #71,r10         ; 71 = 0x47
L20494:
    mov.b       #32,r0          ; 32 = 0x20
    bra         +514            ; +514 = 0x202, pc+514 = L20440
    mov.b       r8,@(r0,r10)
L20507:
;  642: 	if (byte)
    tst.l       r8,r8
    bf          +2              ; pc+2 = L20907
    bra         +506            ; +506 = 0x1fa, pc+506 = L20440
    nop
L20907:
;  643: 	{
;  644: 	    uint8 mask = 1;
    mov.b       #1,r9
;  650: 	    for (int c = 0; c < 8; c++, mask <<= 1)
    mov.b       #0,r10
L20511:
;  651: 	    {
;  652: 		if ((byte & mask) != 0)
    tst.l       r9,r8
    bt          +54             ; +54 = 0x36, pc+54 = L20518
;  653: 		{
;  660: 		    APU.KeyedChannels |= mask;
    extu.b      r9,r1
    mov.l       @(524,pc),r4    ; = _APU
    extu.b      r9,r3
    mov.b       @(6,r4),r0
    extu.b      r0,r0
    or.l        r1,r0
    mov.b       r0,@(6,r4)
;  661: 		    APU.DSP [APU_KON] |= mask;
    add.l       #71,r4          ; 71 = 0x47
    ldc.l       r4,gbr
    mov.b       @(16,gbr),r0    ; 16 = 0x10
    extu.b      r0,r0
    or.l        r3,r0
    mov.b       r0,@(16,gbr)    ; 16 = 0x10
;  662: 		    APU.DSP [APU_KOFF] &= ~mask;
    mov.b       @(32,gbr),r0    ; 32 = 0x20
    not.l       r9,r5
    extu.b      r0,r0
    extu.b      r5,r2
    and.l       r2,r0
    mov.b       r0,@(32,gbr)    ; 32 = 0x20
;  663: 		    APU.DSP [APU_ENDX] &= ~mask;
    add.l       #64,r4          ; 64 = 0x40
    mov.b       @r4,r3
    extu.b      r5,r1
    mov.l       @(488,pc),r0    ; = `?S9xPlaySample@@YAXH@Z`
    extu.b      r3,r3
    and.l       r1,r3
    mov.b       r3,@r4
;  664: 		    S9xPlaySample (c);
    jsr         @r0
    mov.l       r10,r4
;  665: 		}
;  666: 	    }
L20518:
    add.l       #1,r10
    shll.l      r9
    mov.b       #8,r2
    cmp/gt.l    r10,r2
    bt/s        -72             ; -72 = 0xffffffb8, pc-72 = L20511
    extu.b      r9,r9
;  671: 	}
;  672: 	return;
    bra         +426            ; +426 = 0x1aa, pc+426 = L20440
    nop
L20520:
    mov.l       @(452,pc),r7    ; = _APU
    add.l       #11,r7          ; 11 = 0xb
;  675:     case APU_VOL_LEFT + 0x10:
;  676:     case APU_VOL_LEFT + 0x20:
;  677:     case APU_VOL_LEFT + 0x30:
;  678:     case APU_VOL_LEFT + 0x40:
;  679:     case APU_VOL_LEFT + 0x50:
;  680:     case APU_VOL_LEFT + 0x60:
;  681:     case APU_VOL_LEFT + 0x70:
;  682: 	if (byte != APU.DSP [reg])
    mov.l       r9,r0
    nop
    mov.b       @(r0,r7),r2
    extu.b      r2,r2
    cmp/eq.l    r2,r8
    bf          +2              ; pc+2 = L20908
    bra         +394            ; +394 = 0x18a, pc+394 = L20444
    nop
L20908:
;  683: 	{
;  689: 		S9xSetSoundVolume (reg >> 4, (signed char) byte,
;  690: 				   (signed char) APU.DSP [reg + 1]);
    mov.b       #1,r0
    mov.l       r9,r4
    add.l       r9,r0
    mov.b       @(r0,r7),r6
    mov.b       #-4,r1          ; -4 = 0xfffffffc
    mov.l       @(436,pc),r0    ; = `?S9xSetSoundVolume@@YAXHFF@Z`
    exts.b      r8,r5
    jsr         @r0
    shad.l      r1,r4
;  691: 	}
;  692: 	break;
    bra         +372            ; +372 = 0x174, pc+372 = L20444
    nop
L20524:
    mov.l       @(412,pc),r7    ; = _APU
    add.l       #11,r7          ; 11 = 0xb
;  694:     case APU_VOL_RIGHT + 0x10:
;  695:     case APU_VOL_RIGHT + 0x20:
;  696:     case APU_VOL_RIGHT + 0x30:
;  697:     case APU_VOL_RIGHT + 0x40:
;  698:     case APU_VOL_RIGHT + 0x50:
;  699:     case APU_VOL_RIGHT + 0x60:
;  700:     case APU_VOL_RIGHT + 0x70:
;  701: 	if (byte != APU.DSP [reg])
    mov.l       r9,r0
    nop
    mov.b       @(r0,r7),r2
    extu.b      r2,r2
    cmp/eq.l    r2,r8
    bf          +2              ; pc+2 = L20909
    bra         +352            ; +352 = 0x160, pc+352 = L20444
    nop
L20909:
;  702: 	{
;  708: 		S9xSetSoundVolume (reg >> 4, (signed char) APU.DSP [reg - 1],
;  709: 				   (signed char) byte);
    mov.b       #-1,r0          ; -1 = 0xffffffff
    mov.l       r9,r4
    add.l       r9,r0
    mov.b       @(r0,r7),r5
    mov.l       @(396,pc),r0    ; = `?S9xSetSoundVolume@@YAXHFF@Z`
    mov.b       #-4,r1          ; -4 = 0xfffffffc
    exts.b      r8,r6
    jsr         @r0
    shad.l      r1,r4
;  710: 	}
;  711: 	break;
    bra         +330            ; +330 = 0x14a, pc+330 = L20444
    nop
L20528:
;  714:     case APU_P_LOW + 0x10:
;  715:     case APU_P_LOW + 0x20:
;  716:     case APU_P_LOW + 0x30:
;  717:     case APU_P_LOW + 0x40:
;  718:     case APU_P_LOW + 0x50:
;  719:     case APU_P_LOW + 0x60:
;  720:     case APU_P_LOW + 0x70:
;  726: 	    S9xSetSoundHertz (reg >> 4, ((byte + (APU.DSP [reg + 1] << 8)) & FREQUENCY_MASK) * 8);
    mov.l       @(368,pc),r0    ; = _APU
    add.l       #11,r0          ; 11 = 0xb
    mov.l       r9,r4
    mov.b       #1,r1
    mov.l       r8,r5
    add.l       r9,r1
    mov.b       @(r0,r1),r3
    extu.b      r3,r3
    mov.l       @(376,pc),r0    ; = `?S9xSetSoundHertz@@YAXHH@Z`
    mov.b       #-4,r2          ; -4 = 0xfffffffc
    shad.l      r2,r4
    mov.w       @(336,pc),r2    ; = 16383
    shll8.l     r3
    add.l       r3,r5
    and.l       r2,r5
    shll.l      r5
    jsr         @r0
    shll2.l     r5
;  727: 	break;
    bra         +290            ; +290 = 0x122, pc+290 = L20444
    nop
L20529:
;  730:     case APU_P_HIGH + 0x10:
;  731:     case APU_P_HIGH + 0x20:
;  732:     case APU_P_HIGH + 0x30:
;  733:     case APU_P_HIGH + 0x40:
;  734:     case APU_P_HIGH + 0x50:
;  735:     case APU_P_HIGH + 0x60:
;  736:     case APU_P_HIGH + 0x70:
;  742: 	    S9xSetSoundHertz (reg >> 4, 
;  743: 			      (((byte << 8) + APU.DSP [reg - 1]) & FREQUENCY_MASK) * 8);
    mov.l       @(328,pc),r0    ; = _APU
    add.l       #11,r0          ; 11 = 0xb
    mov.l       r9,r4
    mov.b       #-1,r3          ; -1 = 0xffffffff
    mov.l       r8,r5
    add.l       r9,r3
    mov.b       @(r0,r3),r2
    mov.b       #-4,r1          ; -4 = 0xfffffffc
    mov.l       @(336,pc),r0    ; = `?S9xSetSoundHertz@@YAXHH@Z`
    shad.l      r1,r4
    mov.w       @(298,pc),r1    ; = 16383
    shll8.l     r5
    extu.b      r2,r2
    add.l       r2,r5
    and.l       r1,r5
    shll.l      r5
    jsr         @r0
    shll2.l     r5
;  744: 	break;
    bra         +250            ; +250 = 0xfa, pc+250 = L20444
    nop
L20530:
;  747:     case APU_SRCN + 0x10:
;  748:     case APU_SRCN + 0x20:
;  749:     case APU_SRCN + 0x30:
;  750:     case APU_SRCN + 0x40:
;  751:     case APU_SRCN + 0x50:
;  752:     case APU_SRCN + 0x60:
;  753:     case APU_SRCN + 0x70:
;  754: 	if (byte != APU.DSP [reg])
    mov.l       @(288,pc),r0    ; = _APU
    add.l       #11,r0          ; 11 = 0xb
    mov.b       @(r0,r9),r3
    extu.b      r3,r3
    cmp/eq.l    r3,r8
    bf          +2              ; pc+2 = L20910
    bra         +234            ; +234 = 0xea, pc+234 = L20444
    nop
L20910:
;  755: 	{
;  761: 	    S9xSetSoundSample (reg >> 4, byte);
    mov.l       r9,r4
    mov.l       @(288,pc),r0    ; = `?S9xSetSoundSample@@YAXHG@Z`
    mov.b       #-4,r2          ; -4 = 0xfffffffc
    mov.l       r8,r5
    jsr         @r0
    shad.l      r2,r4
;  762: 	}
;  763: 	break;
    bra         +218            ; +218 = 0xda, pc+218 = L20444
    nop
L20532:
    mov.l       @(256,pc),r7    ; = _APU
    add.l       #11,r7          ; 11 = 0xb
;  766:     case APU_ADSR1 + 0x10:
;  767:     case APU_ADSR1 + 0x20:
;  768:     case APU_ADSR1 + 0x30:
;  769:     case APU_ADSR1 + 0x40:
;  770:     case APU_ADSR1 + 0x50:
;  771:     case APU_ADSR1 + 0x60:
;  772:     case APU_ADSR1 + 0x70:
;  773: 	if (byte != APU.DSP [reg])
    mov.l       r9,r0
    nop
    mov.b       @(r0,r7),r1
    extu.b      r1,r1
    cmp/eq.l    r1,r8
    bt          +200            ; +200 = 0xc8, pc+200 = L20444
;  774: 	{
;  780: 	    {
;  781: 		S9xFixEnvelope (reg >> 4, APU.DSP [reg + 2], byte, 
;  782: 			     APU.DSP [reg + 1]);
    mov.b       #2,r0
    mov.l       r9,r4
    add.l       r9,r0
    mov.b       @(r0,r7),r2
    mov.b       #1,r0
    mov.l       r8,r6
    add.l       r9,r0
    mov.b       @(r0,r7),r1
    extu.b      r1,r7
    mov.b       #-4,r3          ; -4 = 0xfffffffc
    extu.b      r2,r5
    bsr         +254            ; +254 = 0xfe, pc+254 = `?S9xFixEnvelope@@YAXHEEE@Z`
    shad.l      r3,r4
;  783: 	    }
;  784: 	}
;  785: 	break;
    bra         +172            ; +172 = 0xac, pc+172 = L20444
    nop
L20534:
    mov.l       @(212,pc),r7    ; = _APU
    add.l       #11,r7          ; 11 = 0xb
;  788:     case APU_ADSR2 + 0x10:
;  789:     case APU_ADSR2 + 0x20:
;  790:     case APU_ADSR2 + 0x30:
;  791:     case APU_ADSR2 + 0x40:
;  792:     case APU_ADSR2 + 0x50:
;  793:     case APU_ADSR2 + 0x60:
;  794:     case APU_ADSR2 + 0x70:
;  795: 	if (byte != APU.DSP [reg])
    mov.l       r9,r0
    nop
    mov.b       @(r0,r7),r3
    extu.b      r3,r3
    cmp/eq.l    r3,r8
    bt          +154            ; +154 = 0x9a, pc+154 = L20444
;  796: 	{
;  802: 	    {
;  803: 		S9xFixEnvelope (reg >> 4, APU.DSP [reg + 1], APU.DSP [reg - 1],
;  804: 			     byte);
    mov.b       #1,r0
    mov.l       r9,r4
    add.l       r9,r0
    mov.b       @(r0,r7),r1
    mov.b       #-1,r0          ; -1 = 0xffffffff
    add.l       r9,r0
    mov.b       @(r0,r7),r3
    mov.l       r8,r7
    mov.b       #-4,r2          ; -4 = 0xfffffffc
    extu.b      r1,r5
    extu.b      r3,r6
    bsr         +208            ; +208 = 0xd0, pc+208 = `?S9xFixEnvelope@@YAXHEEE@Z`
    shad.l      r2,r4
;  805: 	    }
;  806: 	}
;  807: 	break;
    bra         +126            ; +126 = 0x7e, pc+126 = L20444
    nop
L20536:
    mov.l       @(164,pc),r7    ; = _APU
    add.l       #11,r7          ; 11 = 0xb
;  810:     case APU_GAIN + 0x10:
;  811:     case APU_GAIN + 0x20:
;  812:     case APU_GAIN + 0x30:
;  813:     case APU_GAIN + 0x40:
;  814:     case APU_GAIN + 0x50:
;  815:     case APU_GAIN + 0x60:
;  816:     case APU_GAIN + 0x70:
;  817: 	if (byte != APU.DSP [reg])
    mov.l       r9,r0
    nop
    mov.b       @(r0,r7),r2
    extu.b      r2,r2
    cmp/eq.l    r2,r8
    bt          +108            ; +108 = 0x6c, pc+108 = L20444
;  818: 	{
;  824: 	    {
;  825: 		S9xFixEnvelope (reg >> 4, byte, APU.DSP [reg - 2],
;  826: 			     APU.DSP [reg - 1]);
    mov.b       #-2,r0          ; -2 = 0xfffffffe
    mov.l       r9,r4
    add.l       r9,r0
    mov.b       @(r0,r7),r3
    mov.b       #-1,r0          ; -1 = 0xffffffff
    mov.l       r8,r5
    add.l       r9,r0
    mov.b       @(r0,r7),r2
    extu.b      r2,r7
    mov.b       #-4,r1          ; -4 = 0xfffffffc
    extu.b      r3,r6
    bsr         +162            ; +162 = 0xa2, pc+162 = `?S9xFixEnvelope@@YAXHEEE@Z`
    shad.l      r1,r4
;  827: 	    }
;  828: 	}
;  829: 	break;
;  832:     case APU_ENVX + 0x10:
;  833:     case APU_ENVX + 0x20:
;  834:     case APU_ENVX + 0x30:
;  835:     case APU_ENVX + 0x40:
;  836:     case APU_ENVX + 0x50:
;  837:     case APU_ENVX + 0x60:
;  838:     case APU_ENVX + 0x70:
;  839: 	break;
;  842:     case APU_OUTX + 0x10:
;  843:     case APU_OUTX + 0x20:
;  844:     case APU_OUTX + 0x30:
;  845:     case APU_OUTX + 0x40:
;  846:     case APU_OUTX + 0x50:
;  847:     case APU_OUTX + 0x60:
;  848:     case APU_OUTX + 0x70:
;  849: 	break;
;  857: 	break;
    bra         +80             ; +80 = 0x50, pc+80 = L20444
    nop
L20541:
;  860: 	if (byte != APU.DSP [APU_PMON])
    mov.l       @(120,pc),r1    ; = _APU
    mov.b       #56,r0          ; 56 = 0x38
    mov.b       @(r0,r1),r1
    extu.b      r1,r1
    cmp/eq.l    r1,r8
    bt          +66             ; +66 = 0x42, pc+66 = L20444
;  861: 	{
;  885: 		S9xSetFrequencyModulationEnable (byte);
    mov.l       @(104,pc),r0    ; = `?S9xSetFrequencyModulationEnable@@YAXE@Z`
    jsr         @r0
    mov.l       r8,r4
;  886: 	}
;  887: 	break;
    bra         +58             ; +58 = 0x3a, pc+58 = L20444
    nop
L20543:
;  890: 	if (byte != APU.DSP [APU_EON])
    mov.b       #88,r0          ; 88 = 0x58
    mov.l       @(96,pc),r1     ; = _APU
    mov.b       @(r0,r1),r1
    extu.b      r1,r1
    cmp/eq.l    r1,r8
    bt          +44             ; +44 = 0x2c, pc+44 = L20444
;  891: 	{
;  915: 		S9xSetEchoEnable (byte);
    mov.l       @(112,pc),r0    ; = `?S9xSetEchoEnable@@YAXE@Z`
    jsr         @r0
    mov.l       r8,r4
;  916: 	}
;  917: 	break;
    bra         +36             ; +36 = 0x24, pc+36 = L20444
    nop
L20545:
;  920: 	S9xSetEchoFeedback ((signed char) byte);
    mov.l       @(96,pc),r0     ; = `?S9xSetEchoFeedback@@YAXH@Z`
    jsr         @r0
    exts.b      r8,r4
;  921: 	break;
;  924: 	break;
    bra         +26             ; +26 = 0x1a, pc+26 = L20444
    nop
L20548:
;  927: 	S9xSetEchoDelay (byte & 0xf);
    mov.b       #15,r2          ; 15 = 0xf
    mov.l       @(96,pc),r0     ; = `?S9xSetEchoDelay@@YAXH@Z`
    mov.l       r8,r4
    jsr         @r0
    and.l       r2,r4
;  928: 	break;
    bra         +12             ; +12 = 0xc, pc+12 = L20444
    nop
L20549:
;  931:     case APU_C1:
;  932:     case APU_C2:
;  933:     case APU_C3:
;  934:     case APU_C4:
;  935:     case APU_C5:
;  936:     case APU_C6:
;  937:     case APU_C7:
;  938: 	S9xSetFilterCoefficient (reg >> 4, (signed char) byte);
    mov.l       @(44,pc),r0     ; = `?S9xSetFilterCoefficient@@YAXHH@Z`
    mov.l       r9,r4
    mov.b       #-4,r1          ; -4 = 0xfffffffc
    exts.b      r8,r5
    jsr         @r0
    shad.l      r1,r4
;  939: 	break;
L20551:
;  943: 	break;
L20444:
;  946:     if (reg < 0x80)
    mov.w       @(26,pc),r3     ; = 128
    cmp/gt.l    r9,r3
    bf          +4              ; pc+4 = L20440
;  947: 	APU.DSP [reg] = byte;
    mov.l       @(32,pc),r0     ; = _APU
    add.l       #11,r0          ; 11 = 0xb
    mov.b       r8,@(r0,r9)
;  948: }
L20440:
    add.l       #16,sp          ; 16 = 0x10
    lds.l       @sp+,pr
    mov.l       @sp+,r13
    mov.l       @sp+,r12
    mov.l       @sp+,r11
    mov.l       @sp+,r10
    mov.l       @sp+,r9
    rts
    mov.l       @sp+,r8
L20895:
    .data.w     128             ; 128 = 0x80
    .data.w     16383           ; 16383 = 0x3fff
    .data.l     `?S9xSetFilterCoefficient@@YAXHH@Z`
    .data.l     `?S9xSetFrequencyModulationEnable@@YAXE@Z`
    .data.l     _APU
    .data.l     `?S9xSetSoundKeyOff@@YAXH@Z`
    .data.l     `?S9xPlaySample@@YAXH@Z`
    .data.l     `?S9xSetSoundVolume@@YAXHFF@Z`
    .data.l     `?S9xSetSoundSample@@YAXHG@Z`
    .data.l     `?S9xSetEchoFeedback@@YAXH@Z`
    .data.l     `?S9xSetSoundHertz@@YAXHH@Z`
    .data.l     `?S9xSetEchoEnable@@YAXE@Z`
    .data.l     `?S9xSetEchoDelay@@YAXH@Z`
    .endf
;  951: {
    .align      4

`?S9xFixEnvelope@@YAXHEEE@Z`: .entry
    mov.l       r8,@-sp
    mov.l       r9,@-sp
    mov.l       r10,@-sp
    mov.l       r11,@-sp
    sts.l       pr,@-sp
    mov.l       r4,r8
    mov.l       r5,r9
    mov.l       r6,r10
    mov.l       r7,r11
    add.l       #-24,sp         ; -24 = 0xffffffe8
    .prolog
;  952:     if (adsr1 & 0x80)
    mov.w       @(278,pc),r1    ; = 128
    tst.l       r1,r10
    bt          +94             ; +94 = 0x5e, pc+94 = L20559
;  953:     {
;  955: 	static unsigned long AttackRate [16] = {
;  956: 	    4100, 2600, 1500, 1000, 640, 380, 260, 160,
;  957: 	    96, 64, 40, 24, 16, 10, 6, 1
;  958: 	};
;  959: 	static unsigned long DecayRate [8] = {
;  960: 	    1200, 740, 440, 290, 180, 110, 74, 37
;  961: 	};
;  962: 	static unsigned long SustainRate [32] = {
;  963: 	    ~0, 38000, 28000, 24000, 19000, 14000, 12000, 9400,
;  964: 	    7100, 5900, 4700, 3500, 2900, 2400, 1800, 1500,
;  965: 	    1200, 880, 740, 590, 440, 370, 290, 220,
;  966: 	    180, 150, 110, 92, 74, 55, 37, 18
;  967: 	};
;  971: 	if (S9xSetSoundMode (channel, MODE_ADSR))
    mov.l       @(292,pc),r0    ; = `?S9xSetSoundMode@@YAEHH@Z`
    mov.b       #1,r5
    jsr         @r0
    mov.l       r8,r4
    tst.l       r0,r0
    bf          +2              ; pc+2 = L20911
    bra         +246            ; +246 = 0xf6, pc+246 = L20569
    nop
L20911:
;  972: 	{
;  976: 	    int attack = AttackRate [adsr1 & 0xf];
    mov.l       @(288,pc),r2    ; = `$S20561_?AttackRate@?4??S9xFixEnvelope@@YAXHEEE@Z@4PAKA`
    mov.l       r10,r0
    nop
    and.l       #15,r0          ; 15 = 0xf
    shll2.l     r0
    mov.l       @(r0,r2),r5
;  978: 	    if (attack == 1 && !Settings.SoundSync)
    mov.b       #1,r2
    cmp/eq.l    r2,r5
    bf          +12             ; +12 = 0xc, pc+12 = L20568
    mov.l       @(264,pc),r1    ; = _Settings
    mov.b       #88,r0          ; 88 = 0x58
    mov.b       @(r0,r1),r1
    extu.b      r1,r1
    tst.l       r1,r1
    bf          +0              ; pc+0 = L20568
;  979: 		attack = 0;
    mov.b       #0,r5
;  981: 	    S9xSetSoundADSR (channel, attack,
L20568:
;  982: 			     DecayRate [(adsr1 >> 4) & 7],
;  983: 			     SustainRate [adsr2 & 0x1f],
;  984: 			     (adsr2 >> 5) & 7, 8);
    mov.b       #-4,r1          ; -4 = 0xfffffffc
    mov.l       @(256,pc),r0    ; = `$S20563_?DecayRate@?4??S9xFixEnvelope@@YAXHEEE@Z@4PAKA`
    shad.l      r1,r10
    mov.l       @(256,pc),r3    ; = `$S20565_?SustainRate@?4??S9xFixEnvelope@@YAXHEEE@Z@4PAKA`
    mov.b       #7,r2
    mov.l       r8,r4
    and.l       r2,r10
    shll2.l     r10
    mov.l       @(r0,r10),r6
    mov.l       r11,r0
    nop
    and.l       #31,r0          ; 31 = 0x1f
    mov.b       #-5,r1          ; -5 = 0xfffffffb
    shad.l      r1,r11
    shll2.l     r0
    mov.l       @(r0,r3),r7
    and.l       r2,r11
    mov.l       @(212,pc),r0    ; = `?S9xSetSoundADSR@@YAXHHHHHH@Z`
    mov.b       #8,r1
    mov.l       r11,@(16,sp)    ; 16 = 0x10
    jsr         @r0
    mov.l       r1,@(20,sp)     ; 20 = 0x14
;  985: 	}
;  986:     }
;  987:     else
    bra         +166            ; +166 = 0xa6, pc+166 = L20569
    nop
L20559:
;  988:     {
;  990: 	if ((gain & 0x80) == 0)
    mov.w       @(176,pc),r3    ; = 128
    tst.l       r3,r9
    bf          +38             ; +38 = 0x26, pc+38 = L20570
;  991: 	{
;  992: 	    if (S9xSetSoundMode (channel, MODE_GAIN))
    mov.l       @(188,pc),r0    ; = `?S9xSetSoundMode@@YAEHH@Z`
    mov.b       #5,r5
    jsr         @r0
    mov.l       r8,r4
    tst.l       r0,r0
    bt          +146            ; +146 = 0x92, pc+146 = L20572
;  993: 	    {
;  994: 		S9xSetEnvelopeRate (channel, 0, 0, gain & 0x7f);
    mov.l       @(168,pc),r0    ; = `?S9xSetEnvelopeRate@@YAXHKHH@Z`
    mov.b       #127,r1         ; 127 = 0x7f
    mov.l       r8,r4
    and.l       r1,r9
    mov.b       #0,r5
    mov.b       #0,r6
    jsr         @r0
    mov.l       r9,r7
;  995: 		S9xSetEnvelopeHeight (channel, gain & 0x7f);
    mov.l       @(156,pc),r0    ; = `?S9xSetEnvelopeHeight@@YAXHH@Z`
    mov.l       r9,r5
    jsr         @r0
    mov.l       r8,r4
;  996: 	    }
;  997: 	}
;  998: 	else
    bra         +120            ; +120 = 0x78, pc+120 = L20572
    nop
L20570:
;  999: 	{
; 1000: 	    static unsigned long IncreaseRate [32] = {
; 1001: 		~0, 4100, 3100, 2600, 2000, 1500, 1300, 1000,
; 1002: 		770, 640, 510, 380, 320, 260, 190, 160,
; 1003: 		130, 96, 80, 64, 48, 40, 32, 24,
; 1004: 		20, 16, 12, 10, 8, 6, 4, 2
; 1005: 	    };
; 1006: 	    static unsigned long DecreaseRateExp [32] = {
; 1007: 		~0, 38000, 28000, 24000, 19000, 14000, 12000, 9400,
; 1008: 		7100, 5900, 4700, 3500, 2900, 2400, 1800, 1500,
; 1009: 		1200, 880, 740, 590, 440, 370, 290, 220,
; 1010: 		180, 150, 110, 92, 74, 55, 37, 18
; 1011: 	    };
; 1012: 	    if (gain & 0x40)
    mov.l       r9,r0
    nop
    tst.l       #64,r0          ; 64 = 0x40
    bt          +44             ; +44 = 0x2c, pc+44 = L20577
; 1013: 	    {
; 1015: 		if (S9xSetSoundMode (channel, (gain & 0x20) ?
; 1016: 					  MODE_INCREASE_BENT_LINE :
; 1017: 					  MODE_INCREASE_LINEAR))
    mov.l       r9,r0
    nop
    tst.l       #32,r0          ; 32 = 0x20
    bf/s        +2              ; pc+2 = L20627
    mov.b       #7,r5
L20628:
    mov.b       #6,r5
L20627:
    mov.l       @(128,pc),r0    ; = `?S9xSetSoundMode@@YAEHH@Z`
    jsr         @r0
    mov.l       r8,r4
    tst.l       r0,r0
    bt          +88             ; +88 = 0x58, pc+88 = L20579
; 1018: 		{
; 1019: 		    S9xSetEnvelopeRate (channel, IncreaseRate [gain & 0x1f],
; 1020: 					1, 127);
    mov.b       #31,r3          ; 31 = 0x1f
    mov.l       @(100,pc),r0    ; = `$S20574_?IncreaseRate@?BE@??S9xFixEnvelope@@YAXHEEE@Z@4PAKA`
    and.l       r3,r9
    shll2.l     r9
    mov.l       @(r0,r9),r5
    mov.l       @(100,pc),r0    ; = `?S9xSetEnvelopeRate@@YAXHKHH@Z`
    mov.b       #1,r6
    mov.b       #127,r7         ; 127 = 0x7f
    jsr         @r0
    mov.l       r8,r4
; 1021: 		}
; 1022: 	    }
; 1023: 	    else
    bra         +66             ; +66 = 0x42, pc+66 = L20579
    nop
L20577:
    mov.b       #32,r2          ; 32 = 0x20
    mov.l       r9,r4
    and.l       r2,r4
; 1024: 	    {
; 1025: 		uint32 rate = (gain & 0x20) ? DecreaseRateExp [gain & 0x1f] / 2 :
; 1026: 					      IncreaseRate [gain & 0x1f];
    tst.l       r4,r4
    bt          +12             ; +12 = 0xc, pc+12 = L20631
    mov.l       @(72,pc),r0     ; = `$S20576_?DecreaseRateExp@?BE@??S9xFixEnvelope@@YAXHEEE@Z@4PAKA`
    mov.b       #31,r2          ; 31 = 0x1f
    and.l       r2,r9
    shll2.l     r9
    mov.l       @(r0,r9),r5
    bra         +10             ; +10 = 0xa, pc+10 = L20630
    shlr.l      r5
L20631:
    mov.b       #31,r2          ; 31 = 0x1f
    mov.l       @(52,pc),r0     ; = `$S20574_?IncreaseRate@?BE@??S9xFixEnvelope@@YAXHEEE@Z@4PAKA`
    and.l       r2,r9
    shll2.l     r9
    mov.l       @(r0,r9),r5
L20630:
    mov.l       r5,r9
; 1027: 		int mode = (gain & 0x20) ? MODE_DECREASE_EXPONENTIAL
; 1028: 					 : MODE_DECREASE_LINEAR;
    tst.l       r4,r4
    bf/s        +2              ; pc+2 = L20633
    mov.b       #9,r5
L20634:
    mov.b       #8,r5
L20633:
; 1030: 		if (S9xSetSoundMode (channel, mode))
    mov.l       @(52,pc),r0     ; = `?S9xSetSoundMode@@YAEHH@Z`
    jsr         @r0
    mov.l       r8,r4
    tst.l       r0,r0
    bt          +10             ; +10 = 0xa, pc+10 = L20558
; 1031: 		    S9xSetEnvelopeRate (channel, rate, -1, 0);
    mov.l       @(32,pc),r0     ; = `?S9xSetEnvelopeRate@@YAXHKHH@Z`
    mov.l       r9,r5
    mov.b       #-1,r6          ; -1 = 0xffffffff
    mov.b       #0,r7
    jsr         @r0
    mov.l       r8,r4
; 1032: 	    }
L20579:
; 1033: 	}
L20572:
; 1034:     }
L20569:
; 1035: }
L20558:
    add.l       #24,sp          ; 24 = 0x18
    lds.l       @sp+,pr
    mov.l       @sp+,r11
    mov.l       @sp+,r10
    mov.l       @sp+,r9
    rts
    mov.l       @sp+,r8
L20896:
    .data.w     128             ; 128 = 0x80
    .data.l     `$S20574_?IncreaseRate@?BE@??S9xFixEnvelope@@YAXHEEE@Z@4PAKA`
    .data.l     `$S20576_?DecreaseRateExp@?BE@??S9xFixEnvelope@@YAXHEEE@Z@4PAKA`
    .data.l     `?S9xSetEnvelopeRate@@YAXHKHH@Z`
    .data.l     `?S9xSetEnvelopeHeight@@YAXHH@Z`
    .data.l     `?S9xSetSoundMode@@YAEHH@Z`
    .data.l     `?S9xSetSoundADSR@@YAXHHHHHH@Z`
    .data.l     _Settings
    .data.l     `$S20561_?AttackRate@?4??S9xFixEnvelope@@YAXHEEE@Z@4PAKA`
    .data.l     `$S20563_?DecayRate@?4??S9xFixEnvelope@@YAXHEEE@Z@4PAKA`
    .data.l     `$S20565_?SustainRate@?4??S9xFixEnvelope@@YAXHEEE@Z@4PAKA`
    .endf
; 1038: {
    .align      4

_S9xSetAPUControl: .entry
    mov.l       r8,@-sp
    mov.l       r9,@-sp
    mov.l       r10,@-sp
    mov.l       r11,@-sp
    mov.l       r12,@-sp
    mov.l       r13,@-sp
    sts.l       pr,@-sp
    mov.l       r4,r8
    add.l       #-20,sp         ; -20 = 0xffffffec
    .prolog
    mov.b       #1,r1
    mov.l       r8,r9
    and.l       r1,r9
; 1039:     if ((byte & 1) != 0 && !APU.TimerEnabled [0])
    tst.l       r9,r9
    bt          +60             ; +60 = 0x3c, pc+60 = L20806
    mov.l       @(356,pc),r5    ; = _APU
    mov.l       r5,r4
    mov.w       @(338,pc),r0    ; = 180
    add.l       r0,r4
    mov.b       #36,r13         ; 36 = 0x24
    add.l       r4,r13
    mov.b       @r13,r3
    extu.b      r3,r3
    tst.l       r3,r3
    bf          +58             ; +58 = 0x3a, pc+58 = L20807
    mov.l       @(336,pc),r7    ; = _APU
    mov.w       @(316,pc),r2    ; = 210
    add.l       r2,r7
    mov.l       @(336,pc),r6    ; = _IAPU
; 1040:     {
; 1041: 	APU.Timer [0] = 0;
    mov.l       @(332,pc),r3    ; = _IAPU
    mov.b       #0,r0
    mov.w       r0,@(24,r4)     ; 24 = 0x18
; 1042: 	IAPU.RAM [0xfd] = 0;
    mov.l       @(4,r6),r1
    ldc.l       r1,gbr
    mov.b       r0,@(253,gbr)   ; 253 = 0xfd
    mov.l       @(4,r3),r6
; 1043: 	if ((APU.TimerTarget [0] = IAPU.RAM [0xfa]) == 0)
    ldc.l       r6,gbr
    mov.b       @(250,gbr),r0   ; 250 = 0xfa
    extu.b      r0,r1
    tst.l       r1,r1
    bf/s        +30             ; +30 = 0x1e, pc+30 = L20586
    mov.w       r1,@r7
; 1044: 	    APU.TimerTarget [0] = 0x100;
    mov.w       @(292,pc),r3    ; = 256
    mov.w       r3,@r7
; 1045:     }
; 1046:     if ((byte & 2) != 0 && !APU.TimerEnabled [1])
    bra         +22             ; +22 = 0x16, pc+22 = L20586
    nop
L20806:
    mov.l       @(296,pc),r5    ; = _APU
    mov.l       r5,r4
    mov.w       @(276,pc),r0    ; = 180
    add.l       r0,r4
    mov.l       @(292,pc),r6    ; = _IAPU
    mov.b       #36,r13         ; 36 = 0x24
    mov.l       @(4,r6),r6
    bra         +4              ; pc+4 = L20586
    add.l       r4,r13
L20807:
    mov.l       @(280,pc),r6    ; = _IAPU
    mov.l       @(4,r6),r6
L20586:
    mov.b       #2,r3
    mov.l       r8,r12
    and.l       r3,r12
    tst.l       r12,r12
    bt          +52             ; +52 = 0x34, pc+52 = L20809
    mov.l       @(264,pc),r11   ; = _APU
    mov.w       @(244,pc),r2    ; = 217
    add.l       r2,r11
    mov.b       @r11,r3
    extu.b      r3,r3
    tst.l       r3,r3
    bf          +44             ; +44 = 0x2c, pc+44 = L20588
    mov.l       @(248,pc),r7    ; = _APU
    mov.w       @(228,pc),r2    ; = 210
    add.l       r2,r7
    add.l       #2,r7
; 1047:     {
; 1048: 	APU.Timer [1] = 0;
    mov.l       @(244,pc),r2    ; = _IAPU
    mov.b       #0,r0
    mov.w       r0,@(26,r4)     ; 26 = 0x1a
; 1049: 	IAPU.RAM [0xfe] = 0;
    ldc.l       r6,gbr
    mov.b       r0,@(254,gbr)   ; 254 = 0xfe
    mov.l       @(4,r2),r6
; 1050: 	if ((APU.TimerTarget [1] = IAPU.RAM [0xfb]) == 0)
    ldc.l       r6,gbr
    mov.b       @(251,gbr),r0   ; 251 = 0xfb
    extu.b      r0,r3
    tst.l       r3,r3
    bf/s        +14             ; +14 = 0xe, pc+14 = L20588
    mov.w       r3,@r7
; 1051: 	    APU.TimerTarget [1] = 0x100;
    mov.w       @(206,pc),r2    ; = 256
    mov.w       r2,@r7
; 1052:     }
; 1053:     if ((byte & 4) != 0 && !APU.TimerEnabled [2])
    bra         +6              ; pc+6 = L20588
    nop
L20809:
    mov.l       @(208,pc),r11   ; = _APU
    mov.w       @(190,pc),r1    ; = 217
    add.l       r1,r11
L20588:
    mov.b       #4,r2
    mov.l       r8,r10
    and.l       r2,r10
    tst.l       r10,r10
    bt          +56             ; +56 = 0x38, pc+56 = L20812
    mov.l       @(192,pc),r7    ; = _APU
    mov.w       @(178,pc),r1    ; = 218
    add.l       r1,r7
    mov.b       @r7,r2
    extu.b      r2,r2
    tst.l       r2,r2
    bf          +48             ; +48 = 0x30, pc+48 = L20590
    mov.l       @(180,pc),r1    ; = _APU
    mov.w       @(158,pc),r2    ; = 210
    add.l       r2,r1
    add.l       #4,r1
    mov.l       r1,@(16,sp)     ; 16 = 0x10
; 1054:     {
; 1055: 	APU.Timer [2] = 0;
    mov.l       @(172,pc),r3    ; = _IAPU
    mov.b       #0,r0
    mov.w       r0,@(28,r4)     ; 28 = 0x1c
; 1056: 	IAPU.RAM [0xff] = 0;
    ldc.l       r6,gbr
    mov.b       r0,@(255,gbr)   ; 255 = 0xff
    mov.l       @(4,r3),r6
; 1057: 	if ((APU.TimerTarget [2] = IAPU.RAM [0xfc]) == 0)
    ldc.l       r6,gbr
    mov.b       @(252,gbr),r0   ; 252 = 0xfc
    extu.b      r0,r2
    tst.l       r2,r2
    bf/s        +16             ; +16 = 0x10, pc+16 = L20590
    mov.w       r2,@r1
; 1058: 	    APU.TimerTarget [2] = 0x100;
    mov.w       @(134,pc),r1    ; = 256
    mov.l       @(16,sp),r2     ; 16 = 0x10
    mov.w       r1,@r2
; 1059:     }
; 1060:     APU.TimerEnabled [0] = byte & 1;
    bra         +6              ; pc+6 = L20590
    nop
L20812:
    mov.l       @(136,pc),r7    ; = _APU
    mov.w       @(120,pc),r1    ; = 218
    add.l       r1,r7
L20590:
    mov.b       r9,@r13
; 1061:     APU.TimerEnabled [1] = (byte & 2) >> 1;
    shar.l      r12
    mov.b       r12,@r11
; 1062:     APU.TimerEnabled [2] = (byte & 4) >> 2;
    shar.l      r10
    shar.l      r10
    mov.b       r10,@r7
; 1064:     if (byte & 0x10)
    mov.l       r8,r0
    nop
    tst.l       #16,r0          ; 16 = 0x10
    bt          +16             ; +16 = 0x10, pc+16 = L20592
; 1065: 	IAPU.RAM [0xF4] = IAPU.RAM [0xF5] = 0;
    mov.w       @(88,pc),r0     ; = 240
    add.l       r0,r6
    mov.b       #0,r3
    mov.l       r3,r0
    nop
    mov.b       r0,@(5,r6)
    mov.b       r0,@(4,r6)
; 1067:     if (byte & 0x20)
    mov.l       @(100,pc),r1    ; = _IAPU
    mov.l       @(4,r1),r6
L20592:
    mov.l       r8,r0
    nop
    tst.l       #32,r0          ; 32 = 0x20
    bt          +16             ; +16 = 0x10, pc+16 = L20593
; 1068: 	IAPU.RAM [0xF6] = IAPU.RAM [0xF7] = 0;
    mov.w       @(62,pc),r0     ; = 240
    add.l       r0,r6
    mov.b       #0,r3
    mov.l       r3,r0
    nop
    mov.b       r0,@(7,r6)
    mov.b       r0,@(6,r6)
; 1070:     if (byte & 0x80)
    mov.l       @(72,pc),r1     ; = _IAPU
    mov.l       @(4,r1),r6
L20593:
    mov.w       @(42,pc),r2     ; = 128
    tst.l       r2,r8
    bt          +72             ; +72 = 0x48, pc+72 = L20594
    mov.l       @(60,pc),r9     ; = _APU
    add.l       #4,r9
; 1071:     {
; 1072: 	if (!APU.ShowROM)
    mov.b       @r9,r2
    extu.b      r2,r2
    tst.l       r2,r2
    bf          +98             ; +98 = 0x62, pc+98 = L20596
; 1073: 	{
; 1074: 	    memmove (&IAPU.RAM [0xffc0], APUROM, sizeof (APUROM));
    mov.l       @(40,pc),r1     ; = 65472
    add.l       r1,r6
    mov.l       r6,r4
    mov.l       @(36,pc),r2     ; = __imp__memmove
    mov.l       @(48,pc),r5     ; = _APUROM
    mov.l       @r2,r2
    jsr         @r2
    mov.b       #64,r6          ; 64 = 0x40
; 1075: 	    APU.ShowROM = TRUE;
    mov.b       #1,r3
    mov.b       r3,@r9
; 1076: 	}
; 1077:     }
    mov.l       @(32,pc),r1     ; = _IAPU
    mov.l       @(4,r1),r6
; 1078:     else
    bra         +72             ; +72 = 0x48, pc+72 = L20596
    nop
L20897:
    .data.w     128             ; 128 = 0x80
    .data.w     240             ; 240 = 0xf0
    .data.w     210             ; 210 = 0xd2
    .data.w     217             ; 217 = 0xd9
    .data.w     180             ; 180 = 0xb4
    .data.w     218             ; 218 = 0xda
    .data.w     256             ; 256 = 0x100
    .data.l     65472           ; 65472 = 0xffc0
    .data.l     __imp__memmove
    .data.l     _APU
    .data.l     _IAPU
    .data.l     _APUROM
L20594:
    mov.l       @(220,pc),r9    ; = _APU
    add.l       #4,r9
; 1079:     {
; 1080: 	if (APU.ShowROM)
    mov.b       @r9,r3
    extu.b      r3,r3
    tst.l       r3,r3
    bt          +24             ; +24 = 0x18, pc+24 = L20597
; 1081: 	{
; 1082: 	    APU.ShowROM = FALSE;
    mov.b       #0,r2
    mov.l       @(200,pc),r3    ; = 65472
    add.l       r3,r6
    mov.w       @(186,pc),r1    ; = 139
    mov.l       r6,r4
    mov.b       r2,@r9
; 1083: 	    memmove (&IAPU.RAM [0xffc0], APU.ExtraRAM, sizeof (APUROM));
    add.l       r1,r5
    mov.l       @(192,pc),r2    ; = __imp__memmove
    mov.l       @r2,r2
    jsr         @r2
    mov.b       #64,r6          ; 64 = 0x40
; 1084: 	}
; 1085:     }
    mov.l       @(192,pc),r3    ; = _IAPU
    mov.l       @(4,r3),r6
L20597:
L20596:
; 1086:     IAPU.RAM [0xf1] = byte;
    mov.w       @(164,pc),r0    ; = 241
    mov.b       r8,@(r0,r6)
; 1087: }
    add.l       #20,sp          ; 20 = 0x14
    lds.l       @sp+,pr
    mov.l       @sp+,r13
    mov.l       @sp+,r12
    mov.l       @sp+,r11
    mov.l       @sp+,r10
    mov.l       @sp+,r9
    rts
    mov.l       @sp+,r8
    .endf
; 1090: {
    .align      4

_S9xSetAPUTimer: .entry
    .prolog
    mov.l       @(164,pc),r6    ; = _IAPU
    add.l       #4,r6
; 1091:     IAPU.RAM [Address] = byte;
    mov.l       @r6,r0
    mov.b       r5,@(r0,r4)
; 1093:     switch (Address)
; 1094:     {
    add.l       #-128,r4        ; -128 = 0xffffff80
    mov.b       #122,r2         ; 122 = 0x7a
    cmp/eq.l    r4,r2
    bt          +14             ; +14 = 0xe, pc+14 = L20606
    mov.b       #123,r1         ; 123 = 0x7b
    cmp/eq.l    r4,r1
    bt          +46             ; +46 = 0x2e, pc+46 = L20608
    mov.b       #124,r3         ; 124 = 0x7c
    cmp/eq.l    r4,r3
    bt          +78             ; +78 = 0x4e, pc+78 = L20610
    bra         +110            ; +110 = 0x6e, pc+110 = L20603
    nop
L20606:
    mov.l       @(128,pc),r4    ; = _APU
    mov.b       #30,r5          ; 30 = 0x1e
    mov.w       @(110,pc),r0    ; = 180
    add.l       r0,r4
    add.l       r4,r5
; 1097: 	{
; 1098: 	    if ((APU.TimerTarget [0] = IAPU.RAM [0xfa]) == 0)
    add.l       #70,r0          ; 70 = 0x46
    mov.l       @r6,r3
    mov.b       @(r0,r3),r3
    extu.b      r3,r0
    tst.l       r0,r0
    bf/s        +4              ; pc+4 = L20607
    mov.w       r0,@(30,r4)     ; 30 = 0x1e
; 1099: 		APU.TimerTarget [0] = 0x100;
    mov.w       @(92,pc),r2     ; = 256
    mov.w       r2,@r5
; 1100: 	    APU.TimerValueWritten [0] = TRUE;
L20607:
    mov.b       #1,r3
    mov.b       #39,r0          ; 39 = 0x27
    mov.b       r3,@(r0,r4)
; 1101: 	}
; 1102: 	break;
    bra         +72             ; +72 = 0x48, pc+72 = L20603
    nop
L20608:
    mov.b       #32,r5          ; 32 = 0x20
    mov.l       @(88,pc),r4     ; = _APU
    mov.w       @(72,pc),r0     ; = 180
    add.l       r0,r4
    add.l       r4,r5
; 1105: 	{
; 1106: 	    if ((APU.TimerTarget [1] = IAPU.RAM [0xfb]) == 0)
    mov.l       @r6,r2
    add.l       #71,r0          ; 71 = 0x47
    mov.b       @(r0,r2),r2
    extu.b      r2,r2
    tst.l       r2,r2
    bf/s        +4              ; pc+4 = L20609
    mov.w       r2,@r5
; 1107: 		APU.TimerTarget [1] = 0x100;
    mov.w       @(54,pc),r1     ; = 256
    mov.w       r1,@r5
; 1108: 	    APU.TimerValueWritten [1] = TRUE;
L20609:
    mov.b       #1,r2
    mov.b       #40,r0          ; 40 = 0x28
    mov.b       r2,@(r0,r4)
; 1109: 	}
; 1110: 	break;
    bra         +34             ; +34 = 0x22, pc+34 = L20603
    nop
L20610:
    mov.l       @(52,pc),r4     ; = _APU
    mov.b       #34,r5          ; 34 = 0x22
    mov.w       @(34,pc),r0     ; = 180
    add.l       r0,r4
    add.l       r4,r5
; 1113: 	{
; 1114: 	    if ((APU.TimerTarget [2] = IAPU.RAM [0xfc]) == 0)
    add.l       #72,r0          ; 72 = 0x48
    mov.l       @r6,r1
    mov.b       @(r0,r1),r1
    extu.b      r1,r1
    tst.l       r1,r1
    bf/s        +4              ; pc+4 = L20611
    mov.w       r1,@r5
; 1115: 		APU.TimerTarget [2] = 0x100;
    mov.w       @(16,pc),r3     ; = 256
    mov.w       r3,@r5
; 1116: 	    APU.TimerValueWritten [2] = TRUE;
L20611:
    mov.b       #1,r1
    mov.b       #41,r0          ; 41 = 0x29
    mov.b       r1,@(r0,r4)
; 1117: 	}
; 1118: 	break;
L20603:
; 1120: }
    rts
    nop
L20898:
    .data.w     241             ; 241 = 0xf1
    .data.w     139             ; 139 = 0x8b
    .data.w     180             ; 180 = 0xb4
    .data.w     256             ; 256 = 0x100
    .data.w     0               ; align pool
    .data.l     65472           ; 65472 = 0xffc0
    .data.l     __imp__memmove
    .data.l     _APU
    .data.l     _IAPU
    .endf
; 1123: {
    .align      4

_S9xGetAPUDSP: .entry
    mov.l       r8,@-sp
    sts.l       pr,@-sp
    add.l       #-16,sp         ; -16 = 0xfffffff0
    .prolog
    mov.l       @(208,pc),r8    ; = _APU
    add.l       #11,r8          ; 11 = 0xb
; 1124:     uint8 reg = IAPU.RAM [0xf2] & 0x7f;
    mov.l       @(208,pc),r1    ; = _IAPU
    mov.w       @(192,pc),r0    ; = 242
    mov.l       @(4,r1),r1
    mov.b       @(r0,r1),r1
    extu.b      r1,r0
    and.l       #127,r0         ; 127 = 0x7f
    mov.l       r0,r5
; 1125:     uint8 byte = APU.DSP [reg];
    mov.l       r5,r0
    nop
    mov.b       @(r0,r8),r3
    extu.b      r3,r4
; 1127:     switch (reg)
; 1128:     {
    mov.b       #-8,r6          ; -8 = 0xfffffff8
    add.l       r5,r6
    mov.b       #17,r1          ; 17 = 0x11
    cmp/hi.l    r1,r6
    bt          +22             ; +22 = 0x16, pc+22 = L20881
    tst.l       r6,r6
    bt/s        +130            ; +130 = 0x82, pc+130 = L20621
    mov.l       r6,r7
    mov.b       #1,r1
    cmp/eq.l    r7,r1
    bt          +118            ; +118 = 0x76, pc+118 = L20620
    mov.b       #16,r3          ; 16 = 0x10
    cmp/eq.l    r7,r3
    bt          +116            ; +116 = 0x74, pc+116 = L20621
    mov.b       #17,r2          ; 17 = 0x11
    cmp/eq.l    r7,r2
    bt          +106            ; +106 = 0x6a, pc+106 = L20620
L20881:
    add.l       #-32,r6         ; -32 = 0xffffffe0
    mov.l       r6,r7
    mov.b       #17,r1          ; 17 = 0x11
    cmp/hi.l    r1,r7
    bt          +22             ; +22 = 0x16, pc+22 = L20884
    tst.l       r7,r7
    bt/s        +96             ; +96 = 0x60, pc+96 = L20621
    mov.l       r7,r6
    mov.b       #1,r1
    cmp/eq.l    r6,r1
    bt          +84             ; +84 = 0x54, pc+84 = L20620
    mov.b       #16,r3          ; 16 = 0x10
    cmp/eq.l    r6,r3
    bt          +82             ; +82 = 0x52, pc+82 = L20621
    mov.b       #17,r2          ; 17 = 0x11
    cmp/eq.l    r6,r2
    bt          +72             ; +72 = 0x48, pc+72 = L20620
L20884:
    add.l       #-32,r7         ; -32 = 0xffffffe0
    mov.b       #17,r1          ; 17 = 0x11
    cmp/hi.l    r1,r7
    bt          +22             ; +22 = 0x16, pc+22 = L20887
    tst.l       r7,r7
    bt/s        +64             ; +64 = 0x40, pc+64 = L20621
    mov.l       r7,r6
    mov.b       #1,r1
    cmp/eq.l    r6,r1
    bt          +52             ; +52 = 0x34, pc+52 = L20620
    mov.b       #16,r3          ; 16 = 0x10
    cmp/eq.l    r6,r3
    bt          +50             ; +50 = 0x32, pc+50 = L20621
    mov.b       #17,r2          ; 17 = 0x11
    cmp/eq.l    r6,r2
    bt          +40             ; +40 = 0x28, pc+40 = L20620
L20887:
    add.l       #-32,r7         ; -32 = 0xffffffe0
    mov.l       r7,r6
    mov.b       #20,r1          ; 20 = 0x14
    cmp/hi.l    r1,r6
    bt          +54             ; +54 = 0x36, pc+54 = L20624
    tst.l       r6,r6
    bt          +30             ; +30 = 0x1e, pc+30 = L20621
    mov.b       #1,r1
    cmp/eq.l    r6,r1
    bt          +20             ; +20 = 0x14, pc+20 = L20620
    mov.b       #16,r3          ; 16 = 0x10
    cmp/eq.l    r6,r3
    bt          +18             ; +18 = 0x12, pc+18 = L20621
    mov.b       #17,r2          ; 17 = 0x11
    cmp/eq.l    r6,r2
    bt          +8              ; pc+8 = L20620
    mov.b       #20,r1          ; 20 = 0x14
    cmp/eq.l    r6,r1
    bt          +20             ; +20 = 0x14, pc+20 = L20623
    bra         +24             ; +24 = 0x18, pc+24 = L20624
    nop
L20620:
; 1130:     case APU_OUTX + 0x10:
; 1131:     case APU_OUTX + 0x20:
; 1132:     case APU_OUTX + 0x30:
; 1133:     case APU_OUTX + 0x40:
; 1134:     case APU_OUTX + 0x50:
; 1135:     case APU_OUTX + 0x60:
; 1136:     case APU_OUTX + 0x70:
; 1137: 	return (byte);
    bra         +22             ; +22 = 0x16, pc+22 = L20613
    mov.l       r4,r0
L20621:
; 1140:     case APU_ENVX + 0x10:
; 1141:     case APU_ENVX + 0x20:
; 1142:     case APU_ENVX + 0x30:
; 1143:     case APU_ENVX + 0x40:
; 1144:     case APU_ENVX + 0x50:
; 1145:     case APU_ENVX + 0x60:
; 1146:     case APU_ENVX + 0x70:
; 1147: 	return ((uint8) S9xGetEnvelopeHeight (reg >> 4));
    mov.b       #-4,r2          ; -4 = 0xfffffffc
    mov.l       @(28,pc),r0     ; = `?S9xGetEnvelopeHeight@@YAHH@Z`
    shad.l      r2,r5
    jsr         @r0
    mov.l       r5,r4
    bra         +8              ; pc+8 = L20613
    extu.b      r0,r0
L20623:
; 1150: 	APU.DSP [APU_ENDX] = 0;
    mov.b       #0,r2
    mov.b       #124,r0         ; 124 = 0x7c
    mov.b       r2,@(r0,r8)
; 1151: 	break;
L20624:
; 1153: 	break;
L20617:
; 1155:     return (byte);
    mov.l       r4,r0
L20613:
    add.l       #16,sp          ; 16 = 0x10
    lds.l       @sp+,pr
    rts
    mov.l       @sp+,r8
L20899:
    .data.w     242             ; 242 = 0xf2
    .data.w     0               ; align pool
    .data.l     `?S9xGetEnvelopeHeight@@YAHH@Z`
    .data.l     _APU
    .data.l     _IAPU
    .endf
    .end
