; File: C:\Data\Project\Sintendo\DC32Snes9x\underce.cpp
    .export     `?islower@@YAHH@Z`
    .export     `?isdigit@@YAHH@Z`
    .export     `?isalpha@@YAHH@Z`
    .export     `?strrchr@@YAPADPBDH@Z`
    .export     `?stricmp@@YAHPBD0@Z`
    .export     `?strnicmp@@YAHPBD0I@Z`

    .section    .drectve, data, align=4
    .sdata      "-defaultlib:corelibc.lib -defaultlib:coredll.lib"

    .section    .data, data, align=4
$S259_charmap:
    .data.b     0
    .data.b     1
    .data.b     2
    .data.b     3
    .data.b     4
    .data.b     5
    .data.b     6
    .data.b     7
    .data.b     8
    .data.b     9
    .data.b     10              ; 10 = 0xa
    .data.b     11              ; 11 = 0xb
    .data.b     12              ; 12 = 0xc
    .data.b     13              ; 13 = 0xd
    .data.b     14              ; 14 = 0xe
    .data.b     15              ; 15 = 0xf
    .data.b     16              ; 16 = 0x10
    .data.b     17              ; 17 = 0x11
    .data.b     18              ; 18 = 0x12
    .data.b     19              ; 19 = 0x13
    .data.b     20              ; 20 = 0x14
    .data.b     21              ; 21 = 0x15
    .data.b     22              ; 22 = 0x16
    .data.b     23              ; 23 = 0x17
    .data.b     24              ; 24 = 0x18
    .data.b     25              ; 25 = 0x19
    .data.b     26              ; 26 = 0x1a
    .data.b     27              ; 27 = 0x1b
    .data.b     28              ; 28 = 0x1c
    .data.b     29              ; 29 = 0x1d
    .data.b     30              ; 30 = 0x1e
    .data.b     31              ; 31 = 0x1f
    .data.b     32              ; 32 = 0x20
    .data.b     33              ; 33 = 0x21
    .data.b     34              ; 34 = 0x22
    .data.b     35              ; 35 = 0x23
    .data.b     36              ; 36 = 0x24
    .data.b     37              ; 37 = 0x25
    .data.b     38              ; 38 = 0x26
    .data.b     39              ; 39 = 0x27
    .data.b     40              ; 40 = 0x28
    .data.b     41              ; 41 = 0x29
    .data.b     42              ; 42 = 0x2a
    .data.b     43              ; 43 = 0x2b
    .data.b     44              ; 44 = 0x2c
    .data.b     45              ; 45 = 0x2d
    .data.b     46              ; 46 = 0x2e
    .data.b     47              ; 47 = 0x2f
    .data.b     48              ; 48 = 0x30
    .data.b     49              ; 49 = 0x31
    .data.b     50              ; 50 = 0x32
    .data.b     51              ; 51 = 0x33
    .data.b     52              ; 52 = 0x34
    .data.b     53              ; 53 = 0x35
    .data.b     54              ; 54 = 0x36
    .data.b     55              ; 55 = 0x37
    .data.b     56              ; 56 = 0x38
    .data.b     57              ; 57 = 0x39
    .data.b     58              ; 58 = 0x3a
    .data.b     59              ; 59 = 0x3b
    .data.b     60              ; 60 = 0x3c
    .data.b     61              ; 61 = 0x3d
    .data.b     62              ; 62 = 0x3e
    .data.b     63              ; 63 = 0x3f
    .data.b     64              ; 64 = 0x40
    .data.b     97              ; 97 = 0x61
    .data.b     98              ; 98 = 0x62
    .data.b     99              ; 99 = 0x63
    .data.b     100             ; 100 = 0x64
    .data.b     101             ; 101 = 0x65
    .data.b     102             ; 102 = 0x66
    .data.b     103             ; 103 = 0x67
    .data.b     104             ; 104 = 0x68
    .data.b     105             ; 105 = 0x69
    .data.b     106             ; 106 = 0x6a
    .data.b     107             ; 107 = 0x6b
    .data.b     108             ; 108 = 0x6c
    .data.b     109             ; 109 = 0x6d
    .data.b     110             ; 110 = 0x6e
    .data.b     111             ; 111 = 0x6f
    .data.b     112             ; 112 = 0x70
    .data.b     113             ; 113 = 0x71
    .data.b     114             ; 114 = 0x72
    .data.b     115             ; 115 = 0x73
    .data.b     116             ; 116 = 0x74
    .data.b     117             ; 117 = 0x75
    .data.b     118             ; 118 = 0x76
    .data.b     119             ; 119 = 0x77
    .data.b     120             ; 120 = 0x78
    .data.b     121             ; 121 = 0x79
    .data.b     122             ; 122 = 0x7a
    .data.b     91              ; 91 = 0x5b
    .data.b     92              ; 92 = 0x5c
    .data.b     93              ; 93 = 0x5d
    .data.b     94              ; 94 = 0x5e
    .data.b     95              ; 95 = 0x5f
    .data.b     96              ; 96 = 0x60
    .data.b     97              ; 97 = 0x61
    .data.b     98              ; 98 = 0x62
    .data.b     99              ; 99 = 0x63
    .data.b     100             ; 100 = 0x64
    .data.b     101             ; 101 = 0x65
    .data.b     102             ; 102 = 0x66
    .data.b     103             ; 103 = 0x67
    .data.b     104             ; 104 = 0x68
    .data.b     105             ; 105 = 0x69
    .data.b     106             ; 106 = 0x6a
    .data.b     107             ; 107 = 0x6b
    .data.b     108             ; 108 = 0x6c
    .data.b     109             ; 109 = 0x6d
    .data.b     110             ; 110 = 0x6e
    .data.b     111             ; 111 = 0x6f
    .data.b     112             ; 112 = 0x70
    .data.b     113             ; 113 = 0x71
    .data.b     114             ; 114 = 0x72
    .data.b     115             ; 115 = 0x73
    .data.b     116             ; 116 = 0x74
    .data.b     117             ; 117 = 0x75
    .data.b     118             ; 118 = 0x76
    .data.b     119             ; 119 = 0x77
    .data.b     120             ; 120 = 0x78
    .data.b     121             ; 121 = 0x79
    .data.b     122             ; 122 = 0x7a
    .data.b     123             ; 123 = 0x7b
    .data.b     124             ; 124 = 0x7c
    .data.b     125             ; 125 = 0x7d
    .data.b     126             ; 126 = 0x7e
    .data.b     127             ; 127 = 0x7f
    .data.b     -128            ; -128 = 0xffffff80
    .data.b     -127            ; -127 = 0xffffff81
    .data.b     -126            ; -126 = 0xffffff82
    .data.b     -125            ; -125 = 0xffffff83
    .data.b     -124            ; -124 = 0xffffff84
    .data.b     -123            ; -123 = 0xffffff85
    .data.b     -122            ; -122 = 0xffffff86
    .data.b     -121            ; -121 = 0xffffff87
    .data.b     -120            ; -120 = 0xffffff88
    .data.b     -119            ; -119 = 0xffffff89
    .data.b     -118            ; -118 = 0xffffff8a
    .data.b     -117            ; -117 = 0xffffff8b
    .data.b     -116            ; -116 = 0xffffff8c
    .data.b     -115            ; -115 = 0xffffff8d
    .data.b     -114            ; -114 = 0xffffff8e
    .data.b     -113            ; -113 = 0xffffff8f
    .data.b     -112            ; -112 = 0xffffff90
    .data.b     -111            ; -111 = 0xffffff91
    .data.b     -110            ; -110 = 0xffffff92
    .data.b     -109            ; -109 = 0xffffff93
    .data.b     -108            ; -108 = 0xffffff94
    .data.b     -107            ; -107 = 0xffffff95
    .data.b     -106            ; -106 = 0xffffff96
    .data.b     -105            ; -105 = 0xffffff97
    .data.b     -104            ; -104 = 0xffffff98
    .data.b     -103            ; -103 = 0xffffff99
    .data.b     -102            ; -102 = 0xffffff9a
    .data.b     -101            ; -101 = 0xffffff9b
    .data.b     -100            ; -100 = 0xffffff9c
    .data.b     -99             ; -99 = 0xffffff9d
    .data.b     -98             ; -98 = 0xffffff9e
    .data.b     -97             ; -97 = 0xffffff9f
    .data.b     -96             ; -96 = 0xffffffa0
    .data.b     -95             ; -95 = 0xffffffa1
    .data.b     -94             ; -94 = 0xffffffa2
    .data.b     -93             ; -93 = 0xffffffa3
    .data.b     -92             ; -92 = 0xffffffa4
    .data.b     -91             ; -91 = 0xffffffa5
    .data.b     -90             ; -90 = 0xffffffa6
    .data.b     -89             ; -89 = 0xffffffa7
    .data.b     -88             ; -88 = 0xffffffa8
    .data.b     -87             ; -87 = 0xffffffa9
    .data.b     -86             ; -86 = 0xffffffaa
    .data.b     -85             ; -85 = 0xffffffab
    .data.b     -84             ; -84 = 0xffffffac
    .data.b     -83             ; -83 = 0xffffffad
    .data.b     -82             ; -82 = 0xffffffae
    .data.b     -81             ; -81 = 0xffffffaf
    .data.b     -80             ; -80 = 0xffffffb0
    .data.b     -79             ; -79 = 0xffffffb1
    .data.b     -78             ; -78 = 0xffffffb2
    .data.b     -77             ; -77 = 0xffffffb3
    .data.b     -76             ; -76 = 0xffffffb4
    .data.b     -75             ; -75 = 0xffffffb5
    .data.b     -74             ; -74 = 0xffffffb6
    .data.b     -73             ; -73 = 0xffffffb7
    .data.b     -72             ; -72 = 0xffffffb8
    .data.b     -71             ; -71 = 0xffffffb9
    .data.b     -70             ; -70 = 0xffffffba
    .data.b     -69             ; -69 = 0xffffffbb
    .data.b     -68             ; -68 = 0xffffffbc
    .data.b     -67             ; -67 = 0xffffffbd
    .data.b     -66             ; -66 = 0xffffffbe
    .data.b     -65             ; -65 = 0xffffffbf
    .data.b     -64             ; -64 = 0xffffffc0
    .data.b     -31             ; -31 = 0xffffffe1
    .data.b     -30             ; -30 = 0xffffffe2
    .data.b     -29             ; -29 = 0xffffffe3
    .data.b     -28             ; -28 = 0xffffffe4
    .data.b     -27             ; -27 = 0xffffffe5
    .data.b     -26             ; -26 = 0xffffffe6
    .data.b     -25             ; -25 = 0xffffffe7
    .data.b     -24             ; -24 = 0xffffffe8
    .data.b     -23             ; -23 = 0xffffffe9
    .data.b     -22             ; -22 = 0xffffffea
    .data.b     -21             ; -21 = 0xffffffeb
    .data.b     -20             ; -20 = 0xffffffec
    .data.b     -19             ; -19 = 0xffffffed
    .data.b     -18             ; -18 = 0xffffffee
    .data.b     -17             ; -17 = 0xffffffef
    .data.b     -16             ; -16 = 0xfffffff0
    .data.b     -15             ; -15 = 0xfffffff1
    .data.b     -14             ; -14 = 0xfffffff2
    .data.b     -13             ; -13 = 0xfffffff3
    .data.b     -12             ; -12 = 0xfffffff4
    .data.b     -11             ; -11 = 0xfffffff5
    .data.b     -10             ; -10 = 0xfffffff6
    .data.b     -9              ; -9 = 0xfffffff7
    .data.b     -8              ; -8 = 0xfffffff8
    .data.b     -7              ; -7 = 0xfffffff9
    .data.b     -6              ; -6 = 0xfffffffa
    .data.b     -37             ; -37 = 0xffffffdb
    .data.b     -36             ; -36 = 0xffffffdc
    .data.b     -35             ; -35 = 0xffffffdd
    .data.b     -34             ; -34 = 0xffffffde
    .data.b     -33             ; -33 = 0xffffffdf
    .data.b     -32             ; -32 = 0xffffffe0
    .data.b     -31             ; -31 = 0xffffffe1
    .data.b     -30             ; -30 = 0xffffffe2
    .data.b     -29             ; -29 = 0xffffffe3
    .data.b     -28             ; -28 = 0xffffffe4
    .data.b     -27             ; -27 = 0xffffffe5
    .data.b     -26             ; -26 = 0xffffffe6
    .data.b     -25             ; -25 = 0xffffffe7
    .data.b     -24             ; -24 = 0xffffffe8
    .data.b     -23             ; -23 = 0xffffffe9
    .data.b     -22             ; -22 = 0xffffffea
    .data.b     -21             ; -21 = 0xffffffeb
    .data.b     -20             ; -20 = 0xffffffec
    .data.b     -19             ; -19 = 0xffffffed
    .data.b     -18             ; -18 = 0xffffffee
    .data.b     -17             ; -17 = 0xffffffef
    .data.b     -16             ; -16 = 0xfffffff0
    .data.b     -15             ; -15 = 0xfffffff1
    .data.b     -14             ; -14 = 0xfffffff2
    .data.b     -13             ; -13 = 0xfffffff3
    .data.b     -12             ; -12 = 0xfffffff4
    .data.b     -11             ; -11 = 0xfffffff5
    .data.b     -10             ; -10 = 0xfffffff6
    .data.b     -9              ; -9 = 0xfffffff7
    .data.b     -8              ; -8 = 0xfffffff8
    .data.b     -7              ; -7 = 0xfffffff9
    .data.b     -6              ; -6 = 0xfffffffa
    .data.b     -5              ; -5 = 0xfffffffb
    .data.b     -4              ; -4 = 0xfffffffc
    .data.b     -3              ; -3 = 0xfffffffd
    .data.b     -2              ; -2 = 0xfffffffe
    .data.b     -1              ; -1 = 0xffffffff
;    5: int islower(int c) {
    .align      4

    .section    .text, code, align=4

`?islower@@YAHH@Z`: .entry
    .prolog
;    6: 	if(c >= 'a' && c <= 'z') return 1;
    mov.b       #97,r1          ; 97 = 0x61
    cmp/ge.l    r1,r4
    bf          +8              ; pc+8 = L234
    mov.b       #122,r3         ; 122 = 0x7a
    cmp/ge.l    r4,r3
    bf          +2              ; pc+2 = L234
    rts
    mov.b       #1,r0
L234:
    mov.b       #0,r0
L233:
    rts
    nop
    .endf
;   10: int isdigit(int c) {
    .align      4

`?isdigit@@YAHH@Z`: .entry
    .prolog
;   11: 	if(c >= '0' && c <= '9') return 1;
    mov.b       #48,r1          ; 48 = 0x30
    cmp/ge.l    r1,r4
    bf          +8              ; pc+8 = L238
    mov.b       #57,r3          ; 57 = 0x39
    cmp/ge.l    r4,r3
    bf          +2              ; pc+2 = L238
    rts
    mov.b       #1,r0
L238:
    mov.b       #0,r0
L237:
    rts
    nop
    .endf
;   15: int isalpha(int c) {
    .align      4

`?isalpha@@YAHH@Z`: .entry
    .prolog
;   16: 	if((c >= 'A' && c <= 'Z') || (c >= 'a' && c <= 'z')) return 1;
    mov.b       #65,r1          ; 65 = 0x41
    cmp/ge.l    r1,r4
    bf          +4              ; pc+4 = L244
    mov.b       #90,r3          ; 90 = 0x5a
    cmp/ge.l    r4,r3
    bt          +10             ; +10 = 0xa, pc+10 = L243
L244:
    mov.b       #97,r2          ; 97 = 0x61
    cmp/ge.l    r2,r4
    bf          +8              ; pc+8 = L242
    mov.b       #122,r1         ; 122 = 0x7a
    cmp/ge.l    r4,r1
    bf          +2              ; pc+2 = L242
L243:
    rts
    mov.b       #1,r0
L242:
    mov.b       #0,r0
L241:
    rts
    nop
    .endf
;   20: char *strrchr (const char* s, int c) {
    .align      4

`?strrchr@@YAPADPBDH@Z`: .entry
    .prolog
;   21: 	char *rtnval = 0;
    mov.b       #0,r7
;   23: 	do {
L252:
;   24: 		if (*s == c)
    mov.b       @r4,r1
    cmp/eq.l    r5,r1
    bf          +0              ; pc+0 = L256
;   25: 		rtnval = (char*)s;
    mov.l       r4,r7
;   26: 	} while (*s++);
L256:
    mov.l       r4,r6
    mov.b       @r6,r3
    tst.l       r3,r3
    bf/s        -18             ; -18 = 0xffffffee, pc-18 = L252
    add.l       #1,r4
;   27: 	return (rtnval);
    rts
    mov.l       r7,r0
    .endf
;   66: int stricmp(const char* s1, const char* s2) {
    .align      4

`?stricmp@@YAHPBD0@Z`: .entry
    mov.l       r8,@-sp
    mov.l       r9,@-sp
    .prolog
    mov.l       @(152,pc),r8    ; = $S259_charmap
;   67: 	unsigned char u1, u2;
;   69: 	for (;;) {
    mov.l       r8,r9
L522:
;   70: 		u1 = (unsigned char) *s1++;
    mov.b       @r4+,r1
    extu.b      r1,r7
;   71: 		u2 = (unsigned char) *s2++;
    mov.b       @r5+,r2
    extu.b      r2,r6
;   72: 		if(charmap[u1] != charmap[u2]) {
    mov.l       r7,r0
    nop
    mov.b       @(r0,r9),r3
    extu.b      r3,r3
    mov.l       r6,r0
    nop
    mov.b       @(r0,r9),r1
    extu.b      r1,r1
    cmp/eq.l    r1,r3
    bt          +20             ; +20 = 0x14, pc+20 = L531
;   73: 			return charmap[u1] - charmap[u2];
    mov.l       r7,r0
    nop
    mov.b       @(r0,r8),r3
    extu.b      r3,r3
    mov.l       r6,r0
    nop
    mov.b       @(r0,r8),r1
    extu.b      r1,r1
    sub.l       r1,r3
    bra         +6              ; pc+6 = L519
    mov.l       r3,r0
L531:
    tst.l       r7,r7
    bf          -56             ; -56 = 0xffffffc8, pc-56 = L522
;   76: 			return 0;
    mov.b       #0,r0
L519:
    mov.l       @sp+,r9
    rts
    mov.l       @sp+,r8
    .endf
;   81: int strnicmp(const char* s1, const char* s2, size_t n) {
    .align      4

`?strnicmp@@YAHPBD0I@Z`: .entry
    mov.l       r8,@-sp
    mov.l       r9,@-sp
    mov.l       r10,@-sp
    .prolog
;   82: 	unsigned char u1, u2;
;   84: 	for (; n != 0; --n) {
    tst.l       r6,r6
    bt          +66             ; +66 = 0x42, pc+66 = L543
    mov.l       @(76,pc),r8     ; = $S259_charmap
    mov.l       r8,r10
L541:
;   85: 		u1 = (unsigned char) *s1++;
    mov.b       @r4+,r2
    extu.b      r2,r7
;   86: 		u2 = (unsigned char) *s2++;
    mov.b       @r5+,r3
    extu.b      r3,r9
;   87: 		if (charmap[u1] != charmap[u2]) {
    mov.l       r7,r0
    nop
    mov.b       @(r0,r10),r1
    extu.b      r1,r1
    mov.l       r9,r0
    nop
    mov.b       @(r0,r10),r2
    extu.b      r2,r2
    cmp/eq.l    r2,r1
    bt          +20             ; +20 = 0x14, pc+20 = L550
;   88: 			return charmap[u1] - charmap[u2];
    mov.l       r7,r0
    nop
    mov.b       @(r0,r8),r1
    extu.b      r1,r1
    mov.l       r9,r0
    nop
    mov.b       @(r0,r8),r2
    extu.b      r2,r2
    sub.l       r2,r1
    bra         +16             ; +16 = 0x10, pc+16 = L538
    mov.l       r1,r0
L550:
    tst.l       r7,r7
    bf          +2              ; pc+2 = L551
;   91: 			return 0;
    bra         +8              ; pc+8 = L538
    mov.b       #0,r0
L551:
    add.l       #-1,r6          ; -1 = 0xffffffff
    tst.l       r6,r6
    bf          -66             ; -66 = 0xffffffbe, pc-66 = L541
L543:
;   94: 	return 0;
    mov.b       #0,r0
L538:
    mov.l       @sp+,r10
    mov.l       @sp+,r9
    rts
    mov.l       @sp+,r8
L625:
    .data.l     $S259_charmap
    .endf
    .end
