#include <windows.h>
#include "snes9x/snes9x.h"
#include "mapledev.h"
#include "Perstore.h"

static IFlashDevice *pIFlash = NULL;

BOOL PASCAL EnumMapleDevicesCallback(LPCMAPLEDEVICEINSTANCE pmdi,
									 LPVOID context) {

	HRESULT hr;
	IUnknown *pIUnknown;

	hr = MapleCreateDevice(&pmdi->guidDevice, &pIUnknown);
	if(FAILED(hr)) {
		S9xMessage(0, 0, "MapleCreateDevice Failed.");
		return TRUE;
	}

	hr = pIUnknown->QueryInterface(_uuidof(IFlashDevice), (void**)&pIFlash);
	pIUnknown->Release();
	if(FAILED(hr)) {
		S9xMessage(0, 0, "QueryInterface failed.");
		return TRUE;
	}

	S9xMessage(0, 0, "IFlashDevice found");
	return TRUE;
}
