; File: C:\Data\Project\Sintendo\DC32Snes9x\Snes9x\cpuexec.h
    .export     _S9xMainLoop
    .export     _S9xSetIRQ
    .export     _S9xClearIRQ
    .export     _S9xDoHBlankProcessing
    .import     _S9xDoHDMA
    .import     `?S9xOpcode_NMI@@YAXXZ`
    .import     _S9xStartScreenRefresh
    .import     _S9xSA1MainLoop
    .import     __imp__sprintf
    .import     __imp___wfopen
    .import     _IAPU
    .import     `?S9xOpcode_IRQ@@YAXXZ`
    .import     _ICPU
    .import     _S9xApuOpcodes
    .import     _Memory
    .import     _RenderLine
    .import     _S9xSyncSpeed
    .import     _S9xAPUCycles
    .import     _missing
    .import     _S9xEndScreenRefresh
    .import     _APU
    .import     _IPPU
    .import     __imp__mbstowcs
    .import     _CPU
    .import     _Registers
    .import     _Settings
    .import     _S9xStartHDMA
    .import     _SA1
    .import     __imp__fread
    .import     _PPU
    .import     _S9xUpdateJoypads
    .import     _S9xGenerateSound
    .import     _S9xSuperFXExec
    .import     _APURegisters

    .section    .drectve, data, align=4
    .sdata      "-defaultlib:corelibc.lib -defaultlib:coredll.lib"

    .section    .data, data, align=4
`$S20445_?frame@?1??S9xMainLoop@@9@4HA`:
    .data.l     0
;  164: {
    .align      4

    .section    .text, code, align=4

`?S9xReschedule@@YAXXZ`: .entry
    mov.l       r8,@-sp
    mov.l       r9,@-sp
    mov.l       r10,@-sp
    .prolog
    mov.b       #36,r10         ; 36 = 0x24
    mov.l       @(368,pc),r8    ; = _CPU
    add.l       r8,r10
    mov.l       @(36,r8),r7     ; 36 = 0x24
    mov.l       @(356,pc),r5    ; = _Settings
    mov.l       @(8,r5),r6
;  165:     uint8 which;
;  166:     long max;
;  168:     if (CPU.NextEvent >= Settings.HBlankStart)
    cmp/ge.l    r6,r7
    bf          +6              ; pc+6 = L20059
;  169:     {
;  170: 	which = HBLANK_END_EVENT;
    mov.b       #1,r4
;  171: 	max = Settings.H_Max;
    mov.l       @(4,r5),r5
;  172:     }
;  173:     else
    bra         +4              ; pc+4 = L20060
    nop
L20059:
;  174:     {
;  175: 	which = HBLANK_START_EVENT;
    mov.b       #0,r4
;  176: 	max = Settings.HBlankStart;
    mov.l       r6,r5
;  177:     }
L20060:
    mov.l       @(352,pc),r9    ; = _PPU
    mov.w       @(304,pc),r0    ; = 2100
    add.l       r0,r9
    mov.w       @(296,pc),r0    ; = 616
    mov.w       @(r0,r9),r6
;  179:     if ((long) PPU.HTimerPosition < max &&
;  180: 	(long) PPU.HTimerPosition > CPU.NextEvent &&
;  181: 	(!PPU.VTimerEnabled ||
;  182: 	 (PPU.VTimerEnabled && CPU.V_Counter == PPU.IRQVBeamPos)))
    cmp/gt.l    r6,r5
    bf          +32             ; +32 = 0x20, pc+32 = L20063
    cmp/gt.l    r7,r6
    bf          +28             ; +28 = 0x1c, pc+28 = L20063
    mov.l       @(332,pc),r7    ; = _PPU
    mov.w       @(276,pc),r0    ; = 2714
    mov.b       @(r0,r7),r2
    extu.b      r2,r7
    tst.l       r7,r7
    bt          +12             ; +12 = 0xc, pc+12 = L20064
    tst.l       r7,r7
    bt          +12             ; +12 = 0xc, pc+12 = L20063
    mov.w       @(22,r9),r0     ; 22 = 0x16
    extu.w      r0,r3
    mov.l       @(40,r8),r2     ; 40 = 0x28
    cmp/eq.l    r3,r2
    bf          +2              ; pc+2 = L20063
L20064:
;  183:     {
;  184: 	which = HTIMER_EVENT;
    mov.b       #2,r4
;  185: 	max = PPU.HTimerPosition;
    mov.l       r6,r5
;  186:     }
;  187:     CPU.NextEvent = max;
L20063:
    mov.l       r5,@r10
;  188:     CPU.WhichEvent = which;
    mov.l       r4,r0
    nop
    mov.b       r0,@(9,r8)
;  189: }
    mov.l       @sp+,r10
    mov.l       @sp+,r9
    rts
    mov.l       @sp+,r8
    .endf
; File: C:\Data\Project\Sintendo\DC32Snes9x\Snes9x\cpuexec.cpp
;   54: {
    .align      4

_S9xMainLoop: .entry
    mov.l       r8,@-sp
    mov.l       r9,@-sp
    mov.l       r10,@-sp
    mov.l       r11,@-sp
    mov.l       r12,@-sp
    mov.l       r13,@-sp
    sts.l       pr,@-sp
    add.l       #-36,sp         ; -36 = 0xffffffdc
    .prolog
    mov.l       @(256,pc),r2    ; = _IAPU
    mov.b       #12,r11         ; 12 = 0xc
    mov.l       @(256,pc),r12   ; = _CPU
    add.l       r12,r11
    mov.l       @(256,pc),r1    ; = _Registers
    add.l       #2,r1
    mov.l       r2,@(32,sp)     ; 32 = 0x20
    mov.l       r12,r10
    mov.l       r1,@(24,sp)     ; 24 = 0x18
    mov.l       r10,r9
    mov.l       r2,@(16,sp)     ; 16 = 0x10
;   55: 	static int frame = 0;
;   56: 	frame++;
    add.l       #12,r2          ; 12 = 0xc
    mov.l       @(220,pc),r4    ; = `$S20445_?frame@?1??S9xMainLoop@@9@4HA`
    mov.l       @r4,r3
    add.l       #1,r3
    mov.l       r3,@r4
;   57: 	int cycle = 0;
;   59:     for (;;)
    mov.l       r2,@(20,sp)     ; 20 = 0x14
L20447:
;   60:     {
;   61: 	cycle++;
;   67: 	APU_EXECUTE ();
    mov.l       @(20,sp),r1     ; 20 = 0x14
    mov.b       @r1,r1
    extu.b      r1,r1
    tst.l       r1,r1
    bt          +64             ; +64 = 0x40, pc+64 = L20454
    mov.l       @(216,pc),r13   ; = _CPU
    add.l       #32,r13         ; 32 = 0x20
    mov.l       @(200,pc),r4    ; = _APU
    mov.l       @r4,r3
    mov.l       @r13,r1
    cmp/ge.l    r3,r1
    bf          +50             ; +50 = 0x32, pc+50 = L20457
    mov.l       @(32,sp),r3     ; 32 = 0x20
    mov.l       r4,r8
    mov.l       r3,@(28,sp)     ; 28 = 0x1c
L20455:
    mov.l       @(28,sp),r2     ; 28 = 0x1c
    mov.l       @(172,pc),r0    ; = _S9xAPUCycles
    mov.l       @r2,r3
    mov.l       @r8,r1
    mov.b       @r3,r3
    extu.b      r3,r3
    shll2.l     r3
    mov.l       @(r0,r3),r2
    add.l       r2,r1
    mov.l       r1,@r8
    mov.l       @(28,sp),r3     ; 28 = 0x1c
    mov.l       @(156,pc),r0    ; = _S9xApuOpcodes
    mov.l       @r3,r3
    mov.b       @r3,r3
    extu.b      r3,r3
    shll2.l     r3
    mov.l       @(r0,r3),r1
    jsr         @r1
    nop
    mov.l       @r8,r2
    mov.l       @r13,r3
    cmp/ge.l    r2,r3
    bt          -48             ; -48 = 0xffffffd0, pc-48 = L20455
L20457:
L20454:
    mov.l       @r9,r4
;   68: 	if (CPU.Flags)
    tst.l       r4,r4
    bt          +174            ; +174 = 0xae, pc+174 = L20463
;   69: 	{
;   70: 	    if (CPU.Flags & NMI_FLAG)
    mov.w       @(102,pc),r1    ; = 128
    tst.l       r1,r4
    bt          +44             ; +44 = 0x2c, pc+44 = L20464
;   71: 	    {
;   72: 		if (CPU.Cycles >= ONE_CYCLE * 95)
    mov.l       @(32,r12),r3    ; 32 = 0x20
    mov.w       @(92,pc),r1     ; = 570
    cmp/ge.l    r1,r3
    bf          +36             ; +36 = 0x24, pc+36 = L20465
    mov.l       @(132,pc),r4    ; = _CPU
    add.l       #7,r4
;   73: 		{
;   74: 		    CPU.Flags &= ~NMI_FLAG;
    mov.l       @r10,r3
    mov.w       @(86,pc),r1     ; = -129
    and.l       r1,r3
    mov.l       r3,@r10
;   75: 		    if (CPU.WaitingForInterrupt)
    mov.b       @r4,r2
    extu.b      r2,r2
    tst.l       r2,r2
    bt          +8              ; pc+8 = L20466
;   76: 		    {
;   77: 			CPU.WaitingForInterrupt = FALSE;
    mov.b       #0,r1
    mov.b       r1,@r4
;   78: 			CPU.PC++;
    mov.l       @r11,r2
    add.l       #1,r2
    mov.l       r2,@r11
;   79: 		    }
;   80: 		    S9xOpcode_NMI ();
L20466:
    mov.l       @(68,pc),r0     ; = `?S9xOpcode_NMI@@YAXXZ`
    jsr         @r0
    nop
;   81: 		}
;   82: 	    }
    mov.l       @r9,r4
L20465:
;  102: 	    CHECK_SOUND ();
L20464:
;  104: 	    if (CPU.Flags & IRQ_PENDING_FLAG)
    mov.w       @(44,pc),r1     ; = 2048
    tst.l       r1,r4
    bt          +110            ; +110 = 0x6e, pc+110 = L20467
;  105: 	    {
;  106: 		if (CPU.IRQActive && !Settings.DisableIRQ)
    mov.b       @(6,r12),r0
    extu.b      r0,r3
    tst.l       r3,r3
    bt          +92             ; +92 = 0x5c, pc+92 = L20468
    mov.b       #16,r0          ; 16 = 0x10
    mov.l       @(68,pc),r2     ; = _Settings
    mov.b       @(r0,r2),r2
    extu.b      r2,r2
    tst.l       r2,r2
    bf          +80             ; +80 = 0x50, pc+80 = L20468
;  107: 		{
;  108: 		    if (!CheckFlag (IRQ))
    mov.l       @(24,sp),r1     ; 24 = 0x18
    mov.b       @r1,r1
    extu.b      r1,r0
    tst.l       #4,r0
    bf          +80             ; +80 = 0x50, pc+80 = L20470
;  109: 			S9xOpcode_IRQ ();
    mov.l       @(28,pc),r0     ; = `?S9xOpcode_IRQ@@YAXXZ`
    jsr         @r0
    nop
;  110: 		}
    mov.l       @r9,r4
;  111: 		else
    bra         +70             ; +70 = 0x46, pc+70 = L20470
    nop
L20927:
    .data.w     2048            ; 2048 = 0x800
    .data.w     2714            ; 2714 = 0xa9a
    .data.w     570             ; 570 = 0x23a
    .data.w     128             ; 128 = 0x80
    .data.w     616             ; 616 = 0x268
    .data.w     65407           ; 65407 = 0xff7f
    .data.w     2100            ; 2100 = 0x834
    .data.w     0               ; align pool
    .data.l     `?S9xOpcode_NMI@@YAXXZ`
    .data.l     `?S9xOpcode_IRQ@@YAXXZ`
    .data.l     _S9xAPUCycles
    .data.l     _S9xApuOpcodes
    .data.l     `$S20445_?frame@?1??S9xMainLoop@@9@4HA`
    .data.l     _APU
    .data.l     _Settings
    .data.l     _IAPU
    .data.l     _CPU
    .data.l     _Registers
    .data.l     _PPU
L20468:
;  112: 		    CPU.Flags &= ~IRQ_PENDING_FLAG;
    mov.l       @r10,r2
    mov.w       @(392,pc),r3    ; = -2049
    and.l       r3,r2
    mov.l       r2,@r10
    mov.l       @r9,r4
L20470:
;  113: 	    }
;  118: 	    if (CPU.Flags & SCAN_KEYS_FLAG)
L20467:
    mov.b       #16,r1          ; 16 = 0x10
    tst.l       r1,r4
;  119: 		break;
    bf          +76             ; +76 = 0x4c, pc+76 = L20449
L20471:
;  132: 	CPU.PCAtOpcodeStart = CPU.PC;
L20463:
    mov.l       @(400,pc),r13   ; = _CPU
    add.l       #32,r13         ; 32 = 0x20
    mov.l       @r11,r1
    mov.l       r1,@(20,r12)    ; 20 = 0x14
;  135: 	CPU.Cycles += CPU.MemSpeed;
    mov.b       #1,r1
    mov.l       @r13,r2
    mov.l       @(44,r12),r3    ; 44 = 0x2c
    add.l       r3,r2
    mov.l       r2,@r13
;  139: 	(*ICPU.S9xOpcodes [*CPU.PC++].S9xOpcode) ();
    mov.l       @r11,r4
    add.l       r4,r1
    mov.l       r1,@r11
    mov.b       @r4,r3
    extu.b      r3,r3
    mov.l       @(364,pc),r2    ; = _ICPU
    shll2.l     r3
    mov.l       @(4,r2),r0
    mov.l       @(r0,r3),r2
    jsr         @r2
    nop
;  141: 	if (SA1.Executing)
    mov.l       @(368,pc),r1    ; = _SA1
    mov.b       #24,r0          ; 24 = 0x18
    mov.b       @(r0,r1),r1
    extu.b      r1,r1
    tst.l       r1,r1
    bt          +4              ; pc+4 = L20472
;  142: 	    S9xSA1MainLoop ();
    mov.l       @(360,pc),r0    ; = _S9xSA1MainLoop
    jsr         @r0
    nop
;  143: 	DO_HBLANK_CHECK();
L20472:
    mov.l       @r13,r3
    mov.l       @(36,r12),r1    ; 36 = 0x24
    cmp/ge.l    r1,r3
    bt          +2              ; pc+2 = L20935
    bra         -328            ; -328 = 0xfffffeb8, pc-328 = L20447
    nop
L20935:
    bsr         +346            ; +346 = 0x15a, pc+346 = _S9xDoHBlankProcessing
    nop
;  144:     }
    bra         -336            ; -336 = 0xfffffeb0, pc-336 = L20447
    nop
L20449:
;  145:     Registers.PC = CPU.PC - CPU.PCBase;
    mov.l       @r11,r0
    mov.l       @(16,r12),r2    ; 16 = 0x10
    sub.l       r2,r0
    mov.l       @(320,pc),r3    ; = _Registers
    mov.w       r0,@(14,r3)     ; 14 = 0xe
;  146:     S9xPackStatus ();
; File: C:\Data\Project\Sintendo\DC32Snes9x\Snes9x\cpuexec.h
;  104: {
;  105:     Registers.PL &= ~(Zero | Negative | Carry | Overflow);
    mov.l       @(24,sp),r1     ; 24 = 0x18
    mov.l       @(304,pc),r3    ; = _ICPU
    mov.b       @r1,r2
    extu.b      r2,r0
    and.l       #60,r0          ; 60 = 0x3c
    mov.b       r0,@r1
;  106:     Registers.PL |= ICPU._Carry | ((ICPU._Zero == 0) << 1) |
;  107: 		    (ICPU._Negative & 0x80) | (ICPU._Overflow << 6);
    extu.b      r0,r2
    mov.b       @(8,r3),r0
    extu.b      r0,r1
    mov.l       r2,@(28,sp)     ; 28 = 0x1c
    mov.b       @(9,r3),r0
    extu.b      r0,r2
    mov.b       @(10,r3),r0     ; 10 = 0xa
    tst.l       r2,r2
    mov.w       @(260,pc),r3    ; = 128
    movt.l      r2
    shll.l      r2
    or.l        r2,r1
    extu.b      r0,r2
    and.l       r3,r2
    or.l        r2,r1
    mov.l       @(264,pc),r2    ; = _ICPU
    mov.b       #6,r3
    mov.b       @(11,r2),r0     ; 11 = 0xb
    extu.b      r0,r2
    shld.l      r3,r2
    mov.l       @(24,sp),r3     ; 24 = 0x18
    or.l        r2,r1
    mov.l       @(28,sp),r2     ; 28 = 0x1c
    extu.b      r1,r1
    or.l        r1,r2
    mov.b       r2,@r3
;  108: }
; File: C:\Data\Project\Sintendo\DC32Snes9x\Snes9x\cpuexec.cpp
;  146:     S9xPackStatus ();
;  147:     APURegisters.PC = IAPU.PC - IAPU.RAM;
    mov.l       @(32,sp),r2     ; 32 = 0x20
    mov.l       @(236,pc),r1    ; = _APURegisters
    mov.l       @r2,r0
    mov.l       @(16,sp),r3     ; 16 = 0x10
    mov.l       r1,@(32,sp)     ; 32 = 0x20
    mov.l       @(4,r3),r1
    sub.l       r1,r0
    mov.l       @(32,sp),r1     ; 32 = 0x20
    mov.w       r0,@(6,r1)
;  148:     S9xAPUPackStatus ();
; File: C:\Data\Project\Sintendo\DC32Snes9x\Snes9x\apu.h
;   92: {
;   93:     APURegisters.P &= ~(Zero | Negative | Carry | Overflow);
    ldc.l       r3,gbr
    mov.l       @(216,pc),r4    ; = _APURegisters
    mov.b       @r4,r2
    extu.b      r2,r0
    and.l       #60,r0          ; 60 = 0x3c
    mov.b       r0,@r4
;   94:     APURegisters.P |= IAPU._Carry | ((IAPU._Zero == 0) << 1) |
;   95: 		      (IAPU._Zero & 0x80) | (IAPU._Overflow << 6);
    mov.b       @(41,gbr),r0    ; 41 = 0x29
    extu.b      r0,r2
    mov.b       @r4,r1
    extu.b      r1,r1
    tst.l       r2,r2
    mov.l       r1,@(24,sp)     ; 24 = 0x18
    movt.l      r3
    mov.b       @(40,gbr),r0    ; 40 = 0x28
    extu.b      r0,r1
    shll.l      r3
    or.l        r3,r1
    mov.w       @(172,pc),r3    ; = 128
    and.l       r3,r2
    or.l        r2,r1
    mov.l       @(16,sp),r2     ; 16 = 0x10
    mov.b       #6,r3
    ldc.l       r2,gbr
    mov.b       @(42,gbr),r0    ; 42 = 0x2a
    extu.b      r0,r2
    shld.l      r3,r2
    or.l        r2,r1
    mov.l       @(24,sp),r2     ; 24 = 0x18
    extu.b      r1,r1
    or.l        r1,r2
    mov.b       r2,@r4
;   96: }
; File: C:\Data\Project\Sintendo\DC32Snes9x\Snes9x\cpuexec.cpp
;  148:     S9xAPUPackStatus ();
;  149:     if (CPU.Flags & SCAN_KEYS_FLAG)
    mov.l       @r10,r0
    tst.l       #16,r0          ; 16 = 0x10
    bt          +12             ; +12 = 0xc, pc+12 = L20443
;  150:     {
;  154: 	    S9xSyncSpeed ();
    mov.l       @(144,pc),r0    ; = _S9xSyncSpeed
    jsr         @r0
    nop
;  155: 	CPU.Flags &= ~SCAN_KEYS_FLAG;
    mov.l       @r10,r3
    mov.b       #-17,r1         ; -17 = 0xffffffef
    and.l       r1,r3
    mov.l       r3,@r10
;  156:     }
;  157: }
L20443:
    add.l       #36,sp          ; 36 = 0x24
    lds.l       @sp+,pr
    mov.l       @sp+,r13
    mov.l       @sp+,r12
    mov.l       @sp+,r11
    mov.l       @sp+,r10
    mov.l       @sp+,r9
    rts
    mov.l       @sp+,r8
    .endf
;  160: {
    .align      4

_S9xSetIRQ: .entry
    sts.l       pr,@-sp
    add.l       #-16,sp         ; -16 = 0xfffffff0
    .prolog
    mov.l       @(124,pc),r5    ; = _CPU
    extu.b      r4,r2
    mov.b       @(6,r5),r0
    extu.b      r0,r0
    or.l        r2,r0
    mov.b       r0,@(6,r5)
    mov.b       #7,r6
    add.l       r5,r6
;  163:     if (CPU.WaitingForInterrupt)
    mov.b       @(7,r5),r0
    extu.b      r0,r3
    tst.l       r3,r3
    bt          +8              ; pc+8 = L20479
;  164:     {
;  165: 	CPU.WaitingForInterrupt = FALSE;
    mov.b       #0,r2
    mov.b       r2,@r6
;  166: 	CPU.PC++;
    mov.l       @(12,r5),r3     ; 12 = 0xc
    add.l       #1,r3
    mov.l       r3,@(12,r5)     ; 12 = 0xc
;  167:     }
;  168:     if (!Settings.DisableIRQ && !CheckIRQ ())
L20479:
    mov.b       #16,r0          ; 16 = 0x10
    mov.l       @(84,pc),r1     ; = _Settings
    mov.b       @(r0,r1),r1
    extu.b      r1,r1
    tst.l       r1,r1
    bf          +14             ; +14 = 0xe, pc+14 = L20478
    mov.l       @(84,pc),r3     ; = _Registers
    mov.b       @(2,r3),r0
    extu.b      r0,r0
    tst.l       #4,r0
    bf          +4              ; pc+4 = L20478
;  169: 	S9xOpcode_IRQ ();
    mov.l       @(52,pc),r0     ; = `?S9xOpcode_IRQ@@YAXXZ`
    jsr         @r0
    nop
;  170: }
L20478:
    add.l       #16,sp          ; 16 = 0x10
    lds.l       @sp+,pr
    rts
    nop
    .endf
;  173: {
    .align      4

_S9xClearIRQ: .entry
    .prolog
    mov.l       @(52,pc),r5     ; = _CPU
;  174:     CLEAR_IRQ_SOURCE (source);
; File: C:\Data\Project\Sintendo\DC32Snes9x\Snes9x\cpuexec.h
;  111: {
;  112:     CPU.IRQActive &= ~M;
    mov.b       @(6,r5),r0
    extu.b      r0,r0
    not.l       r4,r2
    extu.b      r2,r2
    and.l       r2,r0
    mov.b       r0,@(6,r5)
;  113:     if (!CPU.IRQActive)
    extu.b      r0,r3
    tst.l       r3,r3
    bf          +6              ; pc+6 = L20531
;  114: 	CPU.Flags &= ~IRQ_PENDING_FLAG;
    mov.l       @r5,r2
    mov.w       @(8,pc),r3      ; = -2049
    and.l       r3,r2
    mov.l       r2,@r5
;  115: }
L20531:
; File: C:\Data\Project\Sintendo\DC32Snes9x\Snes9x\cpuexec.cpp
;  174:     CLEAR_IRQ_SOURCE (source);
;  175: }
    rts
    nop
L20928:
    .data.w     128             ; 128 = 0x80
    .data.w     63487           ; 63487 = 0xf7ff
    .data.l     _S9xSyncSpeed
    .data.l     `?S9xOpcode_IRQ@@YAXXZ`
    .data.l     _APURegisters
    .data.l     _ICPU
    .data.l     _Settings
    .data.l     _CPU
    .data.l     _Registers
    .data.l     _SA1
    .data.l     _S9xSA1MainLoop
    .endf
;  178: {
    .align      4

_S9xDoHBlankProcessing: .entry
    mov.l       r8,@-sp
    mov.l       r9,@-sp
    mov.l       r10,@-sp
    mov.l       r11,@-sp
    mov.l       r12,@-sp
    mov.l       r13,@-sp
    sts.l       pr,@-sp
    add.l       #-28,sp         ; -28 = 0xffffffe4
    .prolog
    mov.l       @(300,pc),r10   ; = _CPU
;  180:     CPU.WaitCounter++;
    mov.l       @(28,r10),r1    ; 28 = 0x1c
    add.l       #1,r1
    mov.l       r1,@(28,r10)    ; 28 = 0x1c
;  182:     switch (CPU.WhichEvent)
;  183:     {
    mov.b       @(9,r10),r0
    extu.b      r0,r4
    tst.l       r4,r4
    bt          +18             ; +18 = 0x12, pc+18 = L20490
    mov.b       #1,r1
    cmp/eq.l    r4,r1
    bt          +58             ; +58 = 0x3a, pc+58 = L20492
    mov.b       #2,r3
    cmp/eq.l    r4,r3
    bf          +2              ; pc+2 = L20936
    bra         +976            ; +976 = 0x3d0, pc+976 = L20520
    nop
L20936:
    bra         +1058           ; +1058 = 0x422, pc+1058 = L20487
    nop
L20490:
    mov.l       @(272,pc),r8    ; = _IPPU
    add.l       #1,r8
    mov.b       @r8,r3
    extu.b      r3,r4
;  185: 	if (IPPU.HDMA && CPU.V_Counter <= PPU.ScreenHeight)
    tst.l       r4,r4
    bf          +2              ; pc+2 = L20937
    bra         +1042           ; +1042 = 0x412, pc+1042 = L20487
    nop
L20937:
    mov.l       @(252,pc),r3    ; = _PPU
    mov.w       @(206,pc),r0    ; = 2154
    mov.l       @(40,r10),r2    ; 40 = 0x28
    mov.w       @(r0,r3),r3
    extu.w      r3,r3
    cmp/ge.l    r2,r3
    bt          +2              ; pc+2 = L20938
    bra         +1024           ; +1024 = 0x400, pc+1024 = L20487
    nop
L20938:
;  186: 	    IPPU.HDMA = S9xDoHDMA (IPPU.HDMA);
    mov.l       @(220,pc),r0    ; = _S9xDoHDMA
    jsr         @r0
    nop
    mov.b       r0,@r8
;  187: 	break;
    bra         +1012           ; +1012 = 0x3f4, pc+1012 = L20487
    nop
L20492:
;  190: 	S9xSuperFXExec ();
    mov.l       @(192,pc),r0    ; = _S9xSuperFXExec
    jsr         @r0
    nop
;  193: 	if (Settings.SoundSync)
    mov.l       @(192,pc),r3    ; = _Settings
    mov.b       #88,r0          ; 88 = 0x58
    mov.b       @(r0,r3),r3
    extu.b      r3,r3
    tst.l       r3,r3
    bt          +4              ; pc+4 = L20493
;  194: 	    S9xGenerateSound ();
    mov.l       @(196,pc),r0    ; = _S9xGenerateSound
    jsr         @r0
    nop
;  197: 	CPU.Cycles -= Settings.H_Max;
L20493:
    mov.b       #12,r2          ; 12 = 0xc
    mov.l       @(176,pc),r8    ; = _IAPU
    add.l       r8,r2
    mov.l       @(168,pc),r4    ; = _Settings
    mov.l       @(4,r4),r4
    mov.l       r2,@(16,sp)     ; 16 = 0x10
    mov.l       @(32,r10),r3    ; 32 = 0x20
    sub.l       r4,r3
    mov.l       r3,@(32,r10)    ; 32 = 0x20
;  198: 	if (IAPU.APUExecuting)
    mov.b       @r2,r2
    extu.b      r2,r2
    tst.l       r2,r2
    bt          +10             ; +10 = 0xa, pc+10 = L20494
    mov.l       @(144,pc),r9    ; = _APU
;  199: 	    APU.Cycles -= Settings.H_Max;
    mov.l       @r9,r2
    sub.l       r4,r2
    mov.l       r2,@r9
;  200: 	else
    bra         +6              ; pc+6 = L20495
    nop
L20494:
    mov.l       @(132,pc),r9    ; = _APU
;  201: 	    APU.Cycles = 0;
    mov.b       #0,r1
    mov.l       r1,@r9
L20495:
    mov.l       @(120,pc),r4    ; = _ICPU
;  203: 	CPU.NextEvent = -1;
    mov.b       #-1,r2          ; -1 = 0xffffffff
    mov.l       r2,@(36,r10)    ; 36 = 0x24
;  204: 	ICPU.Scanline++;
    mov.l       @(28,r4),r3     ; 28 = 0x1c
    add.l       #1,r3
    mov.l       r3,@(28,r4)     ; 28 = 0x1c
;  206: 	if (++CPU.V_Counter > (Settings.PAL ? SNES_MAX_PAL_VCOUNTER : SNES_MAX_NTSC_VCOUNTER))
    mov.b       #28,r0          ; 28 = 0x1c
    mov.l       @(116,pc),r1    ; = _Settings
    mov.b       @(r0,r1),r1
    extu.b      r1,r1
    tst.l       r1,r1
    bt          +4              ; pc+4 = L20528
    mov.w       @(88,pc),r5     ; = 312
    bra         +2              ; pc+2 = L20527
    nop
L20528:
    mov.w       @(76,pc),r5     ; = 262
L20527:
    mov.l       @(120,pc),r1    ; = _CPU
    add.l       #40,r1          ; 40 = 0x28
    mov.l       r1,@(20,sp)     ; 20 = 0x14
    mov.l       @r1,r2
    add.l       #1,r2
    cmp/gt.l    r5,r2
    bf/s        +118            ; +118 = 0x76, pc+118 = L20753
    mov.l       r2,@r1
    mov.l       @(108,pc),r11   ; = _PPU
    mov.l       r11,r1
    mov.w       @(64,pc),r0     ; = 2100
    add.l       r0,r1
    mov.l       r11,r13
    mov.w       @(56,pc),r0     ; = 540
    add.l       r0,r13
    mov.w       @(46,pc),r0     ; = 1560
    mov.l       r13,r5
    mov.l       r1,@(24,sp)     ; 24 = 0x18
    add.l       r0,r5
;  207: 	{
;  208: 	    PPU.OAMAddr = PPU.SavedOAMAddr;
    ldc.l       r1,gbr
    mov.w       @(52,gbr),r0    ; 52 = 0x34
    mov.w       r0,@(16,r1)     ; 16 = 0x10
;  209: 	    PPU.OAMFlip = 0;
    mov.b       #0,r0
    ldc.l       r5,gbr
    mov.b       r0,@(18,gbr)    ; 18 = 0x12
;  210: 	    CPU.V_Counter = 0;
    mov.l       @(20,sp),r2     ; 20 = 0x14
    mov.l       r0,@r2
;  211: 	    ICPU.Frame++;
    mov.l       @(24,r4),r3     ; 24 = 0x18
    add.l       #1,r3
    mov.l       r3,@(24,r4)     ; 24 = 0x18
;  212: 	    PPU.HVBeamCounterLatched = 0;
    mov.b       r0,@(32,gbr)    ; 32 = 0x20
;  213: 	    CPU.Flags |= SCAN_KEYS_FLAG;
    mov.l       @r10,r0
    or.l        #16,r0          ; 16 = 0x10
    mov.l       r0,@r10
;  214: 	    S9xStartHDMA ();
    mov.l       @(44,pc),r0     ; = _S9xStartHDMA
    jsr         @r0
    nop
;  215: 	}
;  217: 	if (PPU.VTimerEnabled && !PPU.HTimerEnabled &&
    bra         +78             ; +78 = 0x4e, pc+78 = L20496
    nop
L20929:
    .data.w     262             ; 262 = 0x106
    .data.w     1560            ; 1560 = 0x618
    .data.w     2154            ; 2154 = 0x86a
    .data.w     312             ; 312 = 0x138
    .data.w     540             ; 540 = 0x21c
    .data.w     2100            ; 2100 = 0x834
    .data.l     _ICPU
    .data.l     _S9xSuperFXExec
    .data.l     _APU
    .data.l     _Settings
    .data.l     _IAPU
    .data.l     _S9xDoHDMA
    .data.l     _S9xStartHDMA
    .data.l     _S9xGenerateSound
    .data.l     _CPU
    .data.l     _PPU
    .data.l     _IPPU
L20753:
    mov.l       @(156,pc),r11   ; = _PPU
    mov.l       r11,r2
    mov.w       @(134,pc),r0    ; = 2100
    add.l       r0,r2
    mov.l       r11,r13
    mov.w       @(126,pc),r0    ; = 540
    add.l       r0,r13
    mov.w       @(120,pc),r0    ; = 1500
    mov.l       r13,r5
    mov.l       r2,@(24,sp)     ; 24 = 0x18
    add.l       r0,r5
L20496:
    mov.l       @(136,pc),r12   ; = _PPU
    mov.w       @(108,pc),r3    ; = 2160
    add.l       r3,r12
    mov.l       r12,r4
    mov.w       @(106,pc),r0    ; = 540
    add.l       r0,r4
;  218: 	    CPU.V_Counter == PPU.IRQVBeamPos)
    mov.b       @(14,r4),r0     ; 14 = 0xe
    extu.b      r0,r1
    tst.l       r1,r1
    bt          +86             ; +86 = 0x56, pc+86 = L20754
    mov.b       @(15,r4),r0     ; 15 = 0xf
    extu.b      r0,r3
    tst.l       r3,r3
    bf          +112            ; +112 = 0x70, pc+112 = L20755
    mov.l       @(24,sp),r3     ; 24 = 0x18
    mov.l       @(96,pc),r2     ; = _CPU
    mov.w       @(22,r3),r0     ; 22 = 0x16
    extu.w      r0,r3
    mov.l       @(40,r2),r4     ; 40 = 0x28
    cmp/eq.l    r3,r4
    bf          +102            ; +102 = 0x66, pc+102 = L20497
    mov.l       @(84,pc),r5     ; = _CPU
    add.l       #7,r5
;  219: 	{
;  220: 	    CPU.IRQActive |= PPU_V_BEAM_IRQ_SOURCE;
    mov.b       @(6,r10),r0
    extu.b      r0,r0
    or.l        #2,r0
    mov.b       r0,@(6,r10)
;  222: 	    if (CPU.WaitingForInterrupt)
    mov.b       @r5,r1
    extu.b      r1,r1
    tst.l       r1,r1
    bt          +8              ; pc+8 = L20498
;  223: 	    {
;  224: 		CPU.WaitingForInterrupt = FALSE;
    mov.b       #0,r3
    mov.b       r3,@r5
;  225: 		CPU.PC++;
    mov.l       @(12,r10),r1    ; 12 = 0xc
    add.l       #1,r1
    mov.l       r1,@(12,r10)    ; 12 = 0xc
;  226: 	    }
;  227: 	    if (!Settings.DisableIRQ && !CheckIRQ ())
L20498:
    mov.l       @(52,pc),r2     ; = _Settings
    mov.b       #16,r0          ; 16 = 0x10
    mov.b       @(r0,r2),r2
    extu.b      r2,r2
    tst.l       r2,r2
    bf          +60             ; +60 = 0x3c, pc+60 = L20497
    mov.l       @(48,pc),r1     ; = _Registers
    mov.b       @(2,r1),r0
    extu.b      r0,r0
    tst.l       #4,r0
    bf          +50             ; +50 = 0x32, pc+50 = L20497
;  228: 		S9xOpcode_IRQ ();
    mov.l       @(24,pc),r0     ; = `?S9xOpcode_IRQ@@YAXXZ`
    jsr         @r0
    nop
;  229: 	}
    mov.l       @(28,pc),r1     ; = _CPU
    mov.l       @(40,r1),r4     ; 40 = 0x28
;  231: 	if (CPU.V_Counter == PPU.ScreenHeight + FIRST_VISIBLE_LINE)
    bra         +38             ; +38 = 0x26, pc+38 = L20497
    nop
L20754:
    mov.l       @(20,pc),r3     ; = _CPU
    bra         +32             ; +32 = 0x20, pc+32 = L20497
    mov.l       @(40,r3),r4     ; 40 = 0x28
L20930:
    .data.w     2160            ; 2160 = 0x870
    .data.w     1500            ; 1500 = 0x5dc
    .data.w     540             ; 540 = 0x21c
    .data.w     2100            ; 2100 = 0x834
    .data.l     `?S9xOpcode_IRQ@@YAXXZ`
    .data.l     _Settings
    .data.l     _CPU
    .data.l     _Registers
    .data.l     _PPU
L20755:
    mov.l       @(400,pc),r2    ; = _CPU
    mov.l       @(40,r2),r4     ; 40 = 0x28
L20497:
    mov.l       @(400,pc),r3    ; = _PPU
    mov.w       @(352,pc),r1    ; = 2154
    add.l       r1,r3
    mov.l       r3,@(24,sp)     ; 24 = 0x18
    mov.w       @r3,r3
    extu.w      r3,r5
    mov.b       #1,r2
    add.l       r5,r2
    cmp/eq.l    r2,r4
    bf          +112            ; +112 = 0x70, pc+112 = L20500
;  232: 	{
;  234: 	    S9xEndScreenRefresh ();
    mov.l       @(360,pc),r0    ; = _S9xEndScreenRefresh
    jsr         @r0
    nop
;  235: 	    PPU.FirstSprite = 0;
    mov.b       #0,r0
    mov.l       @(376,pc),r4    ; = _IPPU
    mov.b       #-7,r1          ; -7 = 0xfffffff9
    mov.l       @(340,pc),r3    ; = _missing
    ldc.l       r13,gbr
    mov.b       r0,@(36,gbr)    ; 36 = 0x24
;  236: 	    IPPU.HDMA = 0;
    ldc.l       r3,gbr
    mov.b       r0,@(1,r4)
;  238: 	    missing.dma_this_frame = 0;
    mov.b       r0,@(155,gbr)   ; 155 = 0x9b
;  239: 	    IPPU.MaxBrightness = PPU.Brightness;
    mov.b       @(2,r11),r0
    mov.b       r0,@(3,r4)
;  240: 	    PPU.ForcedBlanking = (Memory.FillRAM [0x2100] >> 7) & 1;
    mov.l       @(336,pc),r4    ; = _Memory
    add.l       #20,r4          ; 20 = 0x14
    mov.l       @r4,r3
    mov.w       @(302,pc),r0    ; = 8448
    mov.b       @(r0,r3),r3
    extu.b      r3,r0
    shad.l      r1,r0
    mov.w       @(296,pc),r1    ; = 128
    and.l       #1,r0
    mov.b       r0,@(1,r12)
;  241: 	    Memory.FillRAM[0x4210] = 0x80;
    mov.l       @r4,r3
    mov.w       @(282,pc),r0    ; = 16912
    mov.b       r1,@(r0,r3)
;  243: 	    if (Memory.FillRAM[0x4200] & 0x80)
    add.l       #-16,r0         ; -16 = 0xfffffff0
    mov.l       @(308,pc),r2    ; = _Memory
    mov.l       @(20,r2),r2     ; 20 = 0x14
    mov.b       @(r0,r2),r2
    extu.b      r2,r2
    tst.l       r1,r2
    bt          +32             ; +32 = 0x20, pc+32 = L20501
    mov.l       @(308,pc),r5    ; = _CPU
    add.l       #7,r5
;  244: 	    {
;  245: 		CPU.NMIActive = TRUE;
    mov.b       #1,r0
    mov.b       r0,@(5,r10)
;  246: 		CPU.Flags |= NMI_FLAG;
    add.l       #127,r0         ; 127 = 0x7f
    mov.l       @r10,r3
    or.l        r0,r3
    mov.l       r3,@r10
;  247: 		if (CPU.WaitingForInterrupt)
    mov.b       @r5,r2
    extu.b      r2,r2
    tst.l       r2,r2
    bt          +8              ; pc+8 = L20502
;  248: 		{
;  249: 		    CPU.WaitingForInterrupt = FALSE;
    mov.b       #0,r1
    mov.b       r1,@r5
;  250: 		    CPU.PC++;
    mov.l       @(12,r10),r2    ; 12 = 0xc
    add.l       #1,r2
    mov.l       r2,@(12,r10)    ; 12 = 0xc
;  251: 		}
;  252: 	    }
L20502:
;  264:         }
L20501:
;  266: 	if (CPU.V_Counter == PPU.ScreenHeight + 3)
    mov.l       @(280,pc),r1    ; = _PPU
    mov.w       @(230,pc),r0    ; = 2154
    mov.l       @(272,pc),r3    ; = _CPU
    mov.w       @(r0,r1),r1
    extu.w      r1,r5
    mov.l       @(40,r3),r4     ; 40 = 0x28
L20500:
    add.l       #3,r5
    cmp/eq.l    r5,r4
    bf          +8              ; pc+8 = L20503
;  267: 	    S9xUpdateJoypads ();
    mov.l       @(236,pc),r0    ; = _S9xUpdateJoypads
    jsr         @r0
    nop
;  269: 	if (CPU.V_Counter == FIRST_VISIBLE_LINE)
    mov.l       @(252,pc),r3    ; = _CPU
    mov.l       @(40,r3),r4     ; 40 = 0x28
L20503:
    mov.b       #1,r1
    cmp/eq.l    r1,r4
    bf          +18             ; +18 = 0x12, pc+18 = L20504
;  270: 	{
;  271: 	    Memory.FillRAM[0x4210] = 0;
    mov.l       @(228,pc),r3    ; = _Memory
    mov.b       #0,r1
    mov.l       @(20,r3),r3     ; 20 = 0x14
    mov.w       @(190,pc),r0    ; = 16912
    mov.b       r1,@(r0,r3)
;  272: 	    S9xStartScreenRefresh ();
    mov.l       @(204,pc),r0    ; = _S9xStartScreenRefresh
    jsr         @r0
    nop
;  273: 	}
;  274: 	if (CPU.V_Counter >= FIRST_VISIBLE_LINE &&
    mov.l       @(224,pc),r2    ; = _CPU
    mov.l       @(40,r2),r4     ; 40 = 0x28
L20504:
;  275: 	    CPU.V_Counter < PPU.ScreenHeight + FIRST_VISIBLE_LINE)
    mov.b       #1,r3
    cmp/ge.l    r3,r4
    bf          +18             ; +18 = 0x12, pc+18 = L20505
    mov.l       @(24,sp),r2     ; 24 = 0x18
    mov.w       @r2,r2
    extu.w      r2,r2
    add.l       #1,r2
    cmp/gt.l    r4,r2
    bf          +6              ; pc+6 = L20505
;  276: 	{
;  277: 	    RenderLine (CPU.V_Counter - FIRST_VISIBLE_LINE);
    add.l       #-1,r4          ; -1 = 0xffffffff
    mov.l       @(196,pc),r0    ; = _RenderLine
    jsr         @r0
    extu.b      r4,r4
;  278: 	}
;  288: 	{
L20505:
    mov.b       #36,r10         ; 36 = 0x24
    mov.l       @(184,pc),r12   ; = _APU
    mov.w       @(156,pc),r0    ; = 180
    add.l       r0,r12
    add.l       r12,r10
;  289: 	    if (APU.TimerEnabled [2])
    mov.b       @(2,r10),r0
    extu.b      r0,r1
    tst.l       r1,r1
    bt          +96             ; +96 = 0x60, pc+96 = L20506
    mov.l       @(168,pc),r5    ; = _APU
    mov.b       #28,r4          ; 28 = 0x1c
    mov.w       @(138,pc),r0    ; = 180
    add.l       r0,r5
    add.l       r5,r4
    add.l       #34,r5          ; 34 = 0x22
;  290: 	    {
;  291: 		APU.Timer [2] += 4;
    mov.w       @r4,r3
    extu.w      r3,r3
    add.l       #4,r3
    mov.w       r3,@r4
;  292: 		while (APU.Timer [2] >= APU.TimerTarget [2])
    mov.w       @r5,r2
    extu.w      r2,r2
    extu.w      r3,r1
    cmp/ge.l    r2,r1
    bf          +66             ; +66 = 0x42, pc+66 = L20509
    mov.w       @(112,pc),r0    ; = 180
    add.l       r0,r9
    mov.l       r9,r6
    add.l       #34,r9          ; 34 = 0x22
    mov.l       @(16,sp),r9     ; 16 = 0x10
    mov.b       #4,r11
    add.l       r8,r11
    mov.b       #28,r7          ; 28 = 0x1c
    add.l       r8,r7
L20507:
;  293: 		{
;  294: 		    IAPU.RAM [0xff] = (IAPU.RAM [0xff] + 1) & 0xf;
    mov.l       @r11,r6
    mov.w       @(94,pc),r0     ; = 255
    add.l       r0,r6
    mov.b       @r6,r1
    extu.b      r1,r0
    add.l       #1,r0
    and.l       #15,r0          ; 15 = 0xf
    mov.b       r0,@r6
;  295: 		    APU.Timer [2] -= APU.TimerTarget [2];
    mov.w       @r5,r1
    extu.w      r1,r1
    mov.w       @r4,r3
    extu.w      r3,r3
    sub.l       r1,r3
    mov.w       r3,@r4
;  297: 		    IAPU.WaitCounter++;
    mov.l       @r7,r2
    add.l       #1,r2
    mov.l       r2,@r7
;  298: 		    IAPU.APUExecuting = TRUE;
    mov.b       #1,r3
    mov.b       r3,@r9
;  300: 		}
    mov.w       @r4,r1
    extu.w      r1,r1
    mov.w       @r5,r2
    extu.w      r2,r2
    cmp/ge.l    r2,r1
    bt          -52             ; -52 = 0xffffffcc, pc-52 = L20507
L20509:
;  301: 	    }
;  302: 	    if (CPU.V_Counter & 1)
L20506:
    mov.l       @(20,sp),r1     ; 20 = 0x14
    mov.l       @r1,r0
    tst.l       #1,r0
    bf          +2              ; pc+2 = L20939
    bra         +280            ; +280 = 0x118, pc+280 = L20487
    nop
L20939:
;  303: 	    {
;  304: 		if (APU.TimerEnabled [0])
    mov.b       @r10,r1
    extu.b      r1,r1
    tst.l       r1,r1
    bt          +112            ; +112 = 0x70, pc+112 = L20516
    mov.l       @(52,pc),r4     ; = _APU
    mov.w       @(20,pc),r3     ; = 204
    add.l       r3,r4
;  305: 		{
;  306: 		    APU.Timer [0]++;
    mov.w       @r4,r1
    extu.w      r1,r1
    add.l       #1,r1
    mov.w       r1,@r4
;  307: 		    if (APU.Timer [0] >= APU.TimerTarget [0])
    bra         +56             ; +56 = 0x38, pc+56 = L20932
    extu.w      r1,r2
L20931:
    .data.w     16912           ; 16912 = 0x4210
    .data.w     2154            ; 2154 = 0x86a
    .data.w     8448            ; 8448 = 0x2100
    .data.w     128             ; 128 = 0x80
    .data.w     204             ; 204 = 0xcc
    .data.w     180             ; 180 = 0xb4
    .data.w     255             ; 255 = 0xff
    .data.w     0               ; align pool
    .data.l     _S9xStartScreenRefresh
    .data.l     _missing
    .data.l     _S9xUpdateJoypads
    .data.l     _S9xEndScreenRefresh
    .data.l     _Memory
    .data.l     _APU
    .data.l     _RenderLine
    .data.l     _CPU
    .data.l     _PPU
    .data.l     _IPPU
L20932:
    mov.w       @(30,r12),r0    ; 30 = 0x1e
    extu.w      r0,r3
    cmp/ge.l    r3,r2
    bf          +30             ; +30 = 0x1e, pc+30 = L20517
;  308: 		    {
;  309: 			IAPU.RAM [0xfd] = (IAPU.RAM [0xfd] + 1) & 0xf;
    mov.l       @(4,r8),r5
    mov.b       #0,r1
    mov.w       @(210,pc),r0    ; = 253
    add.l       r0,r5
    mov.b       @r5,r2
    extu.b      r2,r0
    add.l       #1,r0
    and.l       #15,r0          ; 15 = 0xf
    mov.b       r0,@r5
;  310: 			APU.Timer [0] = 0;
    mov.b       #1,r3
    mov.w       r1,@r4
;  312: 			IAPU.WaitCounter++;
    mov.l       @(28,r8),r2     ; 28 = 0x1c
    add.l       #1,r2
    mov.l       r2,@(28,r8)     ; 28 = 0x1c
;  313: 			IAPU.APUExecuting = TRUE;
    mov.l       @(16,sp),r1     ; 16 = 0x10
    mov.b       r3,@r1
;  315: 		    }
;  316: 		}
L20517:
;  317: 		if (APU.TimerEnabled [1])
L20516:
    mov.b       @(1,r10),r0
    extu.b      r0,r2
    tst.l       r2,r2
    bt          +148            ; +148 = 0x94, pc+148 = L20487
    mov.l       @(188,pc),r4    ; = _APU
    mov.w       @(170,pc),r1    ; = 204
    add.l       r1,r4
    add.l       #2,r4
;  318: 		{
;  319: 		    APU.Timer [1]++;
    mov.w       @r4,r2
    extu.w      r2,r2
    add.l       #1,r2
    mov.w       r2,@r4
;  320: 		    if (APU.Timer [1] >= APU.TimerTarget [1])
    mov.b       #32,r0          ; 32 = 0x20
    mov.w       @(r0,r12),r1
    extu.w      r1,r1
    extu.w      r2,r3
    cmp/ge.l    r1,r3
    bf          +120            ; +120 = 0x78, pc+120 = L20487
;  321: 		    {
;  322: 			IAPU.RAM [0xfe] = (IAPU.RAM [0xfe] + 1) & 0xf;
    mov.l       @(4,r8),r5
    mov.b       #0,r2
    mov.w       @(144,pc),r0    ; = 254
    add.l       r0,r5
    mov.b       @r5,r3
    extu.b      r3,r0
    add.l       #1,r0
    and.l       #15,r0          ; 15 = 0xf
    mov.b       r0,@r5
;  323: 			APU.Timer [1] = 0;
    mov.b       #1,r1
    mov.w       r2,@r4
;  325: 			IAPU.WaitCounter++;
    mov.l       @(28,r8),r3     ; 28 = 0x1c
    add.l       #1,r3
    mov.l       r3,@(28,r8)     ; 28 = 0x1c
;  326: 			IAPU.APUExecuting = TRUE;
    mov.l       @(16,sp),r2     ; 16 = 0x10
    mov.b       r1,@r2
;  328: 		    }
;  329: 		}
;  330: 	    }
;  331: 	}
;  332: 	break;
    bra         +86             ; +86 = 0x56, pc+86 = L20487
    nop
L20520:
    mov.l       @(136,pc),r11   ; = _PPU
    mov.w       @(104,pc),r0    ; = 2714
    mov.b       @(r0,r11),r1
    extu.b      r1,r4
;  334: 	if (!PPU.VTimerEnabled ||
;  335: 	    (PPU.VTimerEnabled && CPU.V_Counter == PPU.IRQVBeamPos))
    tst.l       r4,r4
    bt          +14             ; +14 = 0xe, pc+14 = L20522
    tst.l       r4,r4
    bt          +68             ; +68 = 0x44, pc+68 = L20487
    mov.w       @(88,pc),r0     ; = 2122
    mov.l       @(40,r10),r1    ; 40 = 0x28
    mov.w       @(r0,r11),r2
    extu.w      r2,r2
    cmp/eq.l    r2,r1
    bf          +56             ; +56 = 0x38, pc+56 = L20487
L20522:
    mov.l       @(100,pc),r5    ; = _CPU
    add.l       #7,r5
;  336: 	{
;  337: 	    CPU.IRQActive |= PPU_H_BEAM_IRQ_SOURCE;
    mov.b       @(6,r10),r0
    extu.b      r0,r0
    or.l        #1,r0
    mov.b       r0,@(6,r10)
;  339: 	    if (CPU.WaitingForInterrupt)
    mov.b       @r5,r3
    extu.b      r3,r3
    tst.l       r3,r3
    bt          +8              ; pc+8 = L20523
;  340: 	    {
;  341: 		CPU.WaitingForInterrupt = FALSE;
    mov.b       #0,r2
    mov.b       r2,@r5
;  342: 		CPU.PC++;
    mov.l       @(12,r10),r3    ; 12 = 0xc
    add.l       #1,r3
    mov.l       r3,@(12,r10)    ; 12 = 0xc
;  343: 	    }
;  344: 	    if (!Settings.DisableIRQ && !CheckIRQ ())
L20523:
    mov.b       #16,r0          ; 16 = 0x10
    mov.l       @(60,pc),r1     ; = _Settings
    mov.b       @(r0,r1),r1
    extu.b      r1,r1
    tst.l       r1,r1
    bf          +14             ; +14 = 0xe, pc+14 = L20487
    mov.l       @(64,pc),r3     ; = _Registers
    mov.b       @(2,r3),r0
    extu.b      r0,r0
    tst.l       #4,r0
    bf          +4              ; pc+4 = L20487
;  345: 		S9xOpcode_IRQ ();
    mov.l       @(36,pc),r0     ; = `?S9xOpcode_IRQ@@YAXXZ`
    jsr         @r0
    nop
;  346: 	}
;  347: 	break;
L20487:
;  349:     S9xReschedule ();
    bsr         -1942           ; -1942 = 0xfffff86a, pc-1942 = `?S9xReschedule@@YAXXZ`
    nop
;  350: }
    add.l       #28,sp          ; 28 = 0x1c
    lds.l       @sp+,pr
    mov.l       @sp+,r13
    mov.l       @sp+,r12
    mov.l       @sp+,r11
    mov.l       @sp+,r10
    mov.l       @sp+,r9
    rts
    mov.l       @sp+,r8
L20933:
    .data.w     2122            ; 2122 = 0x84a
    .data.w     2714            ; 2714 = 0xa9a
    .data.w     204             ; 204 = 0xcc
    .data.w     253             ; 253 = 0xfd
    .data.w     254             ; 254 = 0xfe
    .data.w     0               ; align pool
    .data.l     `?S9xOpcode_IRQ@@YAXXZ`
    .data.l     _Settings
    .data.l     _APU
    .data.l     _CPU
    .data.l     _Registers
    .data.l     _PPU
    .endf
    .end
